/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api;

import org.gpdv.core.api.abstractgraph.AbstractGraphEdge;
import org.gpdv.core.api.abstractgraph.AbstractGraph;
import org.gpdv.core.api.abstractgraph.AbstractGraphNode;
import org.openide.util.Exceptions;

/**
 *
 * @author odi
 */
public final class AbstractGraphFactory {
    
    private long graphID;
    private long nodeID;
    private long edgeID;
    private static AbstractGraphFactory instance;

    private AbstractGraphFactory(){
        graphID = 0;
        nodeID = 0;
        edgeID = 0;
    }
    public static synchronized AbstractGraphFactory getFactory(){
        if(instance==null) instance = new AbstractGraphFactory();
        return instance;
    }

    private long getGraphID() {
        return graphID++;
    }

    private long getNodeID() {
        return nodeID++;
    }

    private long getEdgeID() {
        return edgeID++;
    }

    public synchronized AbstractGraph createAbstractGraph(String name, Object object) {
        if(name==null) return null;
        return new AbstractGraph(getGraphID(), name, object);
    }

    public synchronized AbstractGraphNode createAbstractNode(String name, AbstractGraph graph, Object object) {
        if(name==null||graph==null) return null;
        return new AbstractGraphNode(getNodeID(), name, graph, object);
    }

    public synchronized AbstractGraphEdge createAbstractEdge(String name, AbstractGraph graph, AbstractGraphNode source, AbstractGraphNode destination, Object object) {
        if(name==null||graph==null||source==null||destination==null||source.getGraph()!=graph||destination.getGraph()!=graph) return null;
        AbstractGraphEdge e = null;
        try {
            e = new AbstractGraphEdge(getEdgeID(), name, graph, source, destination, object);
        } catch (Exception ex) {
            Exceptions.printStackTrace(ex);
        }
        return e;
    }
}
