/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api;

import java.util.List;
import javax.swing.JComponent;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;
import org.gpdv.services.GraphDesigner;
import org.gpdv.services.GraphLayouter;
import org.gpdv.services.validators.AbstractGraphValidator;
import org.gpdv.services.validators.DesignGraphValidator;
import org.gpdv.services.GraphRouter;
import org.openide.util.Lookup;

/**
 *
 * @author odi
 */
public abstract class GraphView extends JScrollPane implements Lookup.Provider{
    /**
     * returns a JToolBar to control the visualization
     * @return the created toolbar based on the used VisualizationRequest
     */
    public abstract JToolBar getToolBar();

    public abstract JComponent getSatelliteView();

    /**
     * run the currently set GraphLayouter and set all elements to their original position
     */
    public abstract void enforceLayout();

    /**
     * reset all elements to the position assigned by last layout run
     */
    public abstract void resetLayout();

    /**
     * set the used GraphLayouter, automatically calls enforceLayout
     * @param layouter the GraphLayouter to be used
     */
    public abstract void setGraphLayouter(GraphLayouter layouter);

    /**
     * set the used GraphDesigner, automatically updates the view to the new design.
     * Can lead to relayouting the components.
     * @param designer the GraphDesigner to be used
     */
    public abstract void setGraphDesigner(GraphDesigner designer);


    public abstract void setRouter(GraphRouter router);

    // set the used validators
    public abstract void setAbstractGraphValidators(List<AbstractGraphValidator> validators);
    public abstract void setDesignGraphValidators(List<DesignGraphValidator> validators);
}
