/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.abstractgraph;

import java.util.Collections;
import java.util.EventObject;
import java.util.List;
import java.util.Map;

/**
 *
 * @author odi
 */
public class AbstractGraphChangeEvent extends EventObject{
    public static final String NODE_ADDED = "NODE_ADDED";
    public static final String NODE_REMOVED = "NODE_REMOVED";
    public static final String EDGE_ADDED = "EDGE_ADDED";
    public static final String EDGE_REMOVED = "EDGE_REMOVED";
    public static final String PROPERTY_ADDED = "PROPERTY_ADDED";
    public static final String PROPERTY_REMOVED = "PROPERTY_REMOVED";
    public static final String NEW_PROPERTIES = "NEW_PROPERTIES";

    private AbstractGraph graph;
    private AbstractGraphNode node;
    private AbstractGraphEdge edge;
    private Map<String,String> properties;
    private String changeString;

    public AbstractGraphChangeEvent(AbstractGraph graph, String change, AbstractGraphNode node, AbstractGraphEdge edge, Map<String,String> properties){
        super(graph);
        if(graph==null||change==null) throw new IllegalArgumentException();
        if(node==null&&edge==null&&properties==null) throw new IllegalArgumentException();
        this.changeString = change;
        this.graph = graph;
        this.node = node;
        this.edge = edge;
        this.properties = properties;
    }
    
    public String getChangeString(){
        return changeString;
    }
    public AbstractGraph getGraph(){
        return graph;
    }
    public AbstractGraphNode getChangedNode(){
        return node;
    }
    public AbstractGraphEdge getChangedEdge(){
        return edge;
    }
    public Map<String, String> getChangedProperties(){
        if(properties==null) return null;
        return Collections.unmodifiableMap(properties);
    }
}
