/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.abstractgraph;

import java.util.Collections;
import java.util.EventObject;
import java.util.Map;

/**
 *
 * @author odi
 */
public class AbstractGraphEdgeChangeEvent extends EventObject{
    
    public static String NEW_DESTINATION = "NEW_DESTINATION";
    public static String NEW_SOURCE = "NEW_SOURCE";
    public static String PROPERTY_ADDED = "PROPERTY_ADDED";
    public static String PROPERTY_REMOVED = "PROPERTY_REMOVED";
    public static String NEW_PROPERTIES = "NEW_PROPERTIES";
    
    private AbstractGraphEdge edge;
    private String changeString;
    private AbstractGraphNode old;
    private Map<String, String> changedProperties;

    public AbstractGraphEdgeChangeEvent(AbstractGraphEdge edge, String change, AbstractGraphNode old, Map<String, String> changedProperties) {
        super(edge);
        if(edge==null||change==null) throw new IllegalArgumentException();
        if(old==null&&changedProperties==null) throw new IllegalArgumentException();
        this.edge = edge;
        this.changeString = change;
        this.old = old;
        this.changedProperties = changedProperties;
    }

    public String getChangeString() {
        return changeString;
    }

    public AbstractGraphEdge getEdge() {
        return edge;
    }

    public AbstractGraphNode getOldNode() {
        return old;
    }

    public Map<String, String> getChangedProperties() {
        if(changedProperties==null) return null;
        return Collections.unmodifiableMap(changedProperties);
    }
}
