/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.abstractgraph;

import java.util.Collections;
import java.util.EventObject;
import java.util.List;
import java.util.Map;

/**
 *
 * @author odi
 */
public class AbstractGraphNodeChangeEvent extends EventObject{
    public static final String INCOMING_EDGE_ADDED = "INCOMING_EGDE_ADDED";
    public static final String INCOMING_EDGE_REMOVED = "INCOMING_EGDE_REMOVED";
    public static final String OUTGOING_EDGE_ADDED = "OUTGOING_EGDE_ADDED";
    public static final String OUTGOING_EDGE_REMOVED = "OUTGOING_EGDE_REMOVED";
    public static final String PROPERTY_ADDED = "PROPERTY_ADDED";
    public static final String PROPERTY_REMOVED = "PROPERTY_REMOVED";
    public static final String NEW_PROPERTIES = "NEW_PROPERTIES";
    
    private AbstractGraphNode node;
    private String changeString;
    private AbstractGraphEdge edge;
    private Map<String, String> properties;
    
    public AbstractGraphNodeChangeEvent(AbstractGraphNode node, String change, AbstractGraphEdge edge, Map<String, String> properties){
        super(node);
        if(node==null||change==null) throw new IllegalArgumentException();
        if(edge==null&&properties==null) throw new IllegalArgumentException();
        this.node = node;
        this.changeString = change;
        this.edge = edge;
        this.properties = properties;
    }
    
    public AbstractGraphNode getNode(){
        return node;
    }
    public String getChangeString(){
        return changeString;
    }
    public AbstractGraphEdge getChangedEdge(){
        return edge;
    }
    public Map<String, String> getChangedProperties(){
        if(properties==null) return null;
        return Collections.unmodifiableMap(properties);
    }
}
