/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.designgraph;

import java.util.Collections;
import java.util.EventObject;
import java.util.List;
import java.util.Map;

/**
 *
 * @author odi
 */
public class DesignGraphChangeEvent extends EventObject{
    public static final String NODE_ADDED = "NODE_ADDED";
    public static final String NODE_REMOVED = "NODE_REMOVED";
    public static final String EDGE_ADDED = "EDGE_ADDED";
    public static final String EDGE_REMOVED = "EDGE_REMOVED";
    public static final String PROPERTY_ADDED = "PROPERTY_ADDED";
    public static final String PROPERTY_REMOVED = "PROPERTY_REMOVED";
    
    private String changeString;
    private DesignGraph graph;
    private DesignGraphEdge edge;
    private DesignGraphNode node;
    private Map<String, String> changedProperties;
    
    public DesignGraphChangeEvent(DesignGraph graph, String changeString, DesignGraphNode node, DesignGraphEdge edge, Map<String, String> changedProperties){
        super(graph);
        this.graph = graph;
        this.changeString = changeString;
        this.node = node;
        this.edge = edge;
        this.changedProperties = changedProperties;
    }
    
    public String getChangeString(){
        return changeString;
    }

    public DesignGraph getGraph(){
        return graph;
    }

    public DesignGraphNode getChangedNode(){
        return node;
    }

    public DesignGraphEdge getChangedEdge(){
        return edge;
    }

    public Map<String, String> getChangedProperties(){
        if(changedProperties==null) return Collections.emptyMap();
        return Collections.unmodifiableMap(changedProperties);
    }
}
