/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.designgraph;

import java.util.Collections;
import java.util.EventObject;
import java.util.Map;

/**
 *
 * @author odi
 */
public class DesignGraphEdgeChangeEvent extends EventObject{
    public static final String NEW_SOURCE = "NEW_SOURCE";
    public static final String NEW_DESTINATION = "NEW_DESTINATION";
    public static final String NEW_DESIGN = "NEW_DESIGN";
    public static final String PROPERTY_ADDED = "PROPERTY_ADDED";
    public static final String PROPERTY_REMOVED = "PROPERTY_REMOVED";
    
    private DesignGraphEdge edge;
    private String changeString;
    private DesignGraphSlot old;
    private Design design;
    private Map<String, String> changedProperties;

    public DesignGraphEdgeChangeEvent(DesignGraphEdge edge, String change, DesignGraphSlot old, Design design, Map<String, String> changedProperties) {
        super(edge);
        this.edge = edge;
        this.design = design;
        this.changeString = change;
        this.old = old;
        this.changedProperties = changedProperties;
    }

    public String getChangeString() {
        return changeString;
    }

    public DesignGraphEdge getEdge() {
        return edge;
    }

    public DesignGraphSlot getSlot(){
        return old;
    }

    public Map<String, String> getChangedProperties() {
        if(changedProperties==null) return null;
        return Collections.unmodifiableMap(changedProperties);
    }
}
