/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.designgraph;

import java.util.Collections;
import java.util.List;
import java.util.Map;

/**
 *
 * @author odi
 */
public class DesignGraphNodeChangeEvent {
    public static final String INCOMING_SLOT_ADDED = "INCOMING_SLOT_ADDED";
    public static final String INCOMING_SLOT_REMOVED = "INCOMING_SLOT_REMOVED";
    public static final String OUTGOING_SLOT_ADDED = "OUTGOING_SLOT_ADDED";
    public static final String OUTGOING_SLOT_REMOVED = "OUTGOING_SLOT_REMOVED";
    public static final String NEW_DESIGN = "NEW_DESIGN";
    public static final String PROPERTY_ADDED = "PROPERTY_ADDED";
    public static final String PROPERTY_REMOVED = "PROPERTY_REMOVED";

    private DesignGraphNode node;
    private String changeString;
    private DesignGraphSlot slot;
    private Design design;
    private Map<String, String> changedProperties;
    
    public DesignGraphNodeChangeEvent(DesignGraphNode node, String change, DesignGraphSlot old, Design design, Map<String, String> changedProperties){
        this.node = node;
        this.changeString = change;
        this.slot = old;
        this.changedProperties = changedProperties;
    }
    
    public DesignGraphNode getNode(){
        return node;
    }
    public String getChangeString(){
        return changeString;
    }
    public DesignGraphSlot getChangedSlot(){
        return slot;
    }
    public Design getOldDesign(){
        return design;
    }
    public Map<String, String> getChangedProperties(){
        if(changedProperties==null) return null;
        return Collections.unmodifiableMap(changedProperties);
    }
}
