/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.layoutgraph;

import java.util.EventObject;
import java.util.List;

/**
 *
 * @author odi
 */
public class LayoutGraphChangeEvent extends EventObject{
    public static final String NODE_ADDED = "NODE_ADDED";
    public static final String NODE_REMOVED = "NODE_REMOVED";
    public static final String EDGE_ADDED = "EDGE_ADDED";
    public static final String EDGE_REMOVED = "EDGE_REMOVED";

    private LayoutGraph graph;
    private LayoutGraphNode node;
    private LayoutGraphEdge edge;
    private String changeString;

    public LayoutGraphChangeEvent(LayoutGraph graph, String changeString, LayoutGraphNode node, LayoutGraphEdge edge){
        super(graph);
        this.graph = graph;
        this.changeString = changeString;
        this.node = node;
        this.edge = edge;
    }

    public String getChangeString(){
        return changeString;
    }

    public LayoutGraph getGraph(){
        return graph;
    }

    public LayoutGraphNode getChangedNode(){
        return node;
    }

    public LayoutGraphEdge getChangedEdge(){
        return edge;
    }
}
