/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.views;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyVetoException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import javax.swing.Action;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;
import org.gpdv.core.api.abstractgraph.AbstractGraphNode;
import org.gpdv.core.api.VisualizationRequest;
import org.gpdv.core.api.Visualizer;
import org.gpdv.core.implementation.nodes.EdgeNode;
import org.gpdv.core.implementation.nodes.GraphNode;
import org.gpdv.core.implementation.nodes.NodeNode;
import org.gpdv.core.implementation.nodes.SlotNode;
import org.gpdv.core.implementation.views.VisualizationManagementPanel;
import org.openide.util.HelpCtx;
import org.openide.util.LookupEvent;
import org.openide.util.NbBundle;
import org.openide.windows.TopComponent;
//import org.openide.util.ImageUtilities;
import org.netbeans.api.settings.ConvertAsProperties;
import org.openide.actions.CutAction;
import org.openide.explorer.ExplorerManager;
import org.openide.explorer.ExplorerUtils;
import org.openide.nodes.Node;
import org.openide.util.Exceptions;
import org.openide.util.Lookup;
import org.openide.util.LookupListener;
import org.openide.util.actions.CallableSystemAction;
import org.openide.util.actions.SystemAction;
import org.openide.util.lookup.Lookups;
import org.openide.util.lookup.ProxyLookup;
import org.openide.windows.IOProvider;
import org.openide.windows.OutputWriter;

/**
 * Top component which displays something.
 */
@ConvertAsProperties(
    dtd="-//org.gpdv.core.api.views//Visualization//EN",
    autostore=false
)
public final class VisualizationTopComponent extends TopComponent implements ExplorerManager.Provider, PropertyChangeListener{

    // THIS PANEL IS A TOPCOMPONENT
    // INCLUDES VISUALIZATIONMANAGEMENTPANEL
    // WILL BE MOVED FROM API TO IMPLEMENTATION PACKAGE

//    private static VisualizationTopComponent instance;
    /** path to the icon used by the component and its open action */
//    static final String ICON_PATH = "SET/PATH/TO/ICON/HERE";

    private static final String PREFERRED_ID = "VisualizationTopComponent";
    private static int count = 0;
    private static VisualizationTopComponent singleton;
    private static VisualizationRequest standaloneRequest;

    // PRIVATE FIELDS to decide if repaintable, listening for all graphs, ...
    private ExplorerManager manager;
    private boolean standalone;
    private VisualizationManagementPanel panel;

    private TopComponent.Registry registry;


    public VisualizationTopComponent(){
        this(Visualizer.getVisualizer().getVisualizationRequest().standalone(true));
    }

    public VisualizationTopComponent(VisualizationRequest request){
        initComponents();
        setName((NbBundle.getMessage(VisualizationTopComponent.class, "CTL_VisualizationTopComponent"))+" "+(++count));
        setToolTipText(NbBundle.getMessage(VisualizationTopComponent.class, "HINT_VisualizationTopComponent"));
//        setIcon(ImageUtilities.loadImage(ICON_PATH, true));
//        final OutputWriter io = IOProvider.getDefault().getIO (this.getName(), false).getOut();
        this.manager = new ExplorerManager();
        panel = new VisualizationManagementPanel(request);
        if(request.standalone()||(request.getAbstractGraph()==null&&request.getDesignGraph()==null)){
            this.setStandalone();
        }
        if(request.getAbstractGraph()!=null){
            setName(request.getAbstractGraph().getName());
        }
        // MANAGER IS SET and can be used by VisualizationManagementPanel
        this.setLayout(new BorderLayout());
//        panel = new VisualizationManagementPanel(request, this.manager);
        add(panel, BorderLayout.CENTER);
        JToolBar tb = panel.getToolBar();
        if(tb!=null) add(panel.getToolBar(), BorderLayout.NORTH);
        associateLookup(panel.getLookup());
    }

    public static VisualizationTopComponent getStandaloneVisualizer(){
        if(singleton==null){
            singleton = new VisualizationTopComponent();
            singleton.setName(NbBundle.getMessage(VisualizationTopComponent.class, "CTL_StandaloneVisualizationTopComponent"));
        }
        return singleton;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    /**
     * Gets default instance. Do not use directly: reserved for *.settings files only,
     * i.e. deserialization routines; otherwise you could get a non-deserialized instance.
     * To obtain the singleton instance, use {@link #findInstance}.
     */
    public static synchronized VisualizationTopComponent getDefault() {
//        if (instance == null) {
//            instance = new VisualizationTopComponent();
//        }
        return new VisualizationTopComponent(); //instance;
    }

    /**
     * Obtain the VisualizationTopComponent instance. Never call {@link #getDefault} directly!
     */
    public static synchronized VisualizationTopComponent findInstance() {
//        TopComponent win = WindowManager.getDefault().findTopComponent(PREFERRED_ID);
//        if (win == null) {
//            Logger.getLogger(VisualizationTopComponent.class.getName()).warning(
//                    "Cannot find " + PREFERRED_ID + " component. It will not be located properly in the window system.");
//            return getDefault();
//        }
//        if (win instanceof VisualizationTopComponent) {
//            return (VisualizationTopComponent) win;
//        }
//        Logger.getLogger(VisualizationTopComponent.class.getName()).warning(
//                "There seem to be multiple components with the '" + PREFERRED_ID +
//                "' ID. That is a potential source of errors and unexpected behavior.");
        return getDefault();
    }

    @Override
    public int getPersistenceType() {
        return TopComponent.PERSISTENCE_NEVER;
    }

    @Override
    public void componentOpened() {
        // TODO add custom code on component opening
        if(standalone){
            registry.addPropertyChangeListener(this);
            this.propertyChange(null);
        }
    }

    @Override
    public void componentClosed() {
        // TODO add custom code on component closing
        if(standalone) registry.removePropertyChangeListener(this);
    }

    void writeProperties(java.util.Properties p) {
        // better to version settings since initial version as advocated at
        // http://wiki.apidesign.org/wiki/PropertyFiles
        p.setProperty("version", "1.0");
        // TODO store your settings
    }

    Object readProperties(java.util.Properties p) {
        VisualizationTopComponent singleton1 = VisualizationTopComponent.getDefault();
        singleton1.readPropertiesImpl(p);
        return singleton1;
    }

    private void readPropertiesImpl(java.util.Properties p) {
        String version = p.getProperty("version");
        // TODO read your settings according to their version
    }

    @Override
    protected String preferredID() {
        return PREFERRED_ID;
    }

    public ExplorerManager getExplorerManager() {
        return panel.getExplorerManager();
    }

    // only active in standalone mode
    // listens for graphs in active topcomponents
        // example: a topcomponent uses Visualizer.Utils to create node representation and
        // wants to visualize different graphs in one window (textual graph builder, ...)
        // -> no need for repeated opening/closing of new topcomponents to visualize the active graph
        // -> just put the active nodes in the tc's lookup
    public void propertyChange(PropertyChangeEvent evt) {
        if(evt!=null){
            if(registry.getActivated()==this) return;
            if(!(evt.getPropertyName().equals(TopComponent.Registry.PROP_ACTIVATED)||evt.getPropertyName().equals(TopComponent.Registry.PROP_ACTIVATED_NODES))) return;
        }
//        if(evt!=null&&((!(evt.getPropertyName().equals(TopComponent.Registry.PROP_ACTIVATED)||evt.getPropertyName().equals(TopComponent.Registry.PROP_ACTIVATED_NODES)))||registry.getActivated()==this)) return;
        Node[] nodes = registry.getActivatedNodes();
        GraphNode an = null;
        ArrayList<Node> selectedNodes = new ArrayList<Node>();
        for(Node n : nodes){
            if(an==null){   // no graph discovered yet
                if(n instanceof GraphNode){
                    an = (GraphNode) n;
                } else if(n instanceof EdgeNode){
                    an = ((EdgeNode)n).getGraphNode();
                    selectedNodes.add(n);
                } else if(n instanceof NodeNode){
                    an = ((NodeNode)n).getGraphNode();
                    selectedNodes.add(n);
                } else if(n instanceof SlotNode){
                    an = ((SlotNode)n).getNodeNode().getGraphNode();
                    selectedNodes.add(n);
                }
            } else {    // graph discovered
                if(n instanceof EdgeNode && ((EdgeNode)n).getGraphNode()==an){
                    selectedNodes.add(n);
                } else if(n instanceof NodeNode && ((NodeNode)n).getGraphNode()==an){
                    selectedNodes.add(n);
                } else if(n instanceof SlotNode && ((SlotNode)n).getNodeNode().getGraphNode()==an){
                    selectedNodes.add(n);
                }
            }
        }
        if(an!=null && getExplorerManager().getRootContext()!=an) getExplorerManager().setRootContext(an);
        try {
            if(an!=null && !selectedNodes.isEmpty()){
                getExplorerManager().setSelectedNodes(selectedNodes.toArray(new Node[selectedNodes.size()]));
            } else if(an!=null){
                getExplorerManager().setSelectedNodes(new Node[]{getExplorerManager().getRootContext()});
            }
        } catch (PropertyVetoException ex) {
            Exceptions.printStackTrace(ex);
        }
    }

    private void setStandalone() {
        standalone = true;
        this.registry = TopComponent.getRegistry();
    }
}
