/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gpdv.core.implementation.actions;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.SwingUtilities;
import org.gpdv.core.api.abstractgraph.AbstractGraphNode;
import org.gpdv.core.api.abstractgraph.GraphPropertyProvider;
import org.openide.DialogDescriptor;
import org.openide.DialogDisplayer;
import org.openide.NotifyDescriptor;
import org.openide.util.ContextAwareAction;
import org.openide.util.Lookup;
import org.openide.util.NbBundle;
import org.openide.util.Utilities;
import org.openide.util.actions.Presenter;

public final class AddPropertyAction extends AbstractAction implements ContextAwareAction {

    private Lookup context;
    private String name;
    private String value;
    private PropertyPanel p;
    private ActionListener l;
    private ResourceBundle bundle;

    public AddPropertyAction(){
        this(Utilities.actionsGlobalContext());
    }

    private AddPropertyAction(Lookup context){
        putValue(Action.NAME, NbBundle.getMessage(AddPropertyAction.class, "CTL_AddPropertyAction"));
        this.context = context;
        p = new PropertyPanel();
        l = this;
        bundle = NbBundle.getBundle(AddPropertyAction.class);
    }

    public void actionPerformed(ActionEvent e) {
        // TODO implement action body
        final GraphPropertyProvider n = context.lookup(GraphPropertyProvider.class);
        if(n!=null){
//            n.addProperty("Property "+System.currentTimeMillis(), Long.toString(System.currentTimeMillis()));
            DialogDescriptor dialog = new DialogDescriptor(p, bundle.getString("addproperty"), true, new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    if(e.getSource() == DialogDescriptor.CANCEL_OPTION) return;
                    name = p.getPropertyName();
                    value = p.getPropertyValue();
                    boolean nameCorrect = name!=null&&!name.trim().isEmpty();
                    boolean valueCorrect = value!=null&&!value.trim().isEmpty();
                    if(nameCorrect&&valueCorrect){
                        n.addProperty(name, value);
                    } else {
                        Exception ex;
                        if(!nameCorrect&&!valueCorrect){
                            ex = new Exception(bundle.getString("errornameandvalue"));
                        } else if(!nameCorrect){
                            ex = new Exception(bundle.getString("errorname"));
                        } else {
                            ex = new Exception(bundle.getString("errorvalue"));
                        }
                        NotifyDescriptor nd = new NotifyDescriptor.Exception(ex);
                        DialogDisplayer.getDefault().notify(nd);
                        Runnable r = new Runnable() {
                            public void run() {
                                l.actionPerformed(null);
                            }
                        };
                        SwingUtilities.invokeLater(r);
                    }
                }
            });
            DialogDisplayer.getDefault().notifyLater(dialog);
        }
    }

    public Action createContextAwareInstance(Lookup actionContext) {
        return new AddPropertyAction(actionContext);
    }
}
