/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gpdv.core.implementation.actions;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.SwingUtilities;
import org.gpdv.core.api.abstractgraph.GraphPropertyProvider;
import org.openide.DialogDisplayer;
import org.openide.NotifyDescriptor;
import org.openide.util.ContextAwareAction;
import org.openide.util.Lookup;
import org.openide.util.NbBundle;
import org.openide.util.Utilities;
import org.openide.util.actions.Presenter;

public final class ChangePropertyAction extends AbstractAction implements ContextAwareAction, Presenter.Popup {

    private Lookup context;
    private ResourceBundle bundle;

    public ChangePropertyAction(){
        this(Utilities.actionsGlobalContext());
    }

    private ChangePropertyAction(Lookup context){
        putValue(Action.NAME, NbBundle.getMessage(ChangePropertyAction.class, "CTL_ChangePropertyAction"));
        this.context = context;
        this.bundle = NbBundle.getBundle(ChangePropertyAction.class);
    }

    public void actionPerformed(final ActionEvent e) {
        // TODO implement action body
        Object o = e.getSource();
        if(o instanceof JMenuItem){
            JMenuItem i = (JMenuItem)o;
            GraphPropertyProvider n = context.lookup(GraphPropertyProvider.class);
            if(n!=null){
                String key = (String) i.getClientProperty("key");
                if(key!=null){
                    NotifyDescriptor.InputLine nd = new NotifyDescriptor.InputLine(bundle.getString("newvalue"), bundle.getString("changeproperty"));
                    Object object = DialogDisplayer.getDefault().notify(nd);
                    if(object.equals(NotifyDescriptor.OK_OPTION)){
                        String newValue = nd.getInputText();
                        if(newValue==null||newValue.trim().isEmpty()){
                            Exception ex = new Exception(bundle.getString("errornewvalue"));
                            NotifyDescriptor nd1 = new NotifyDescriptor.Exception(ex);
                            DialogDisplayer.getDefault().notify(nd1);
                            Runnable r = new Runnable() {
                                public void run() {
                                    actionPerformed(e);
                                }
                            };
                            SwingUtilities.invokeLater(r);
                        } else {
                            n.removeProperty(key);
                            n.addProperty(key, newValue);
                        }
                    }
                }
            }
        }
    }

    public Action createContextAwareInstance(Lookup actionContext) {
        return new ChangePropertyAction(actionContext);
    }

    public JMenuItem getPopupPresenter() {
        JMenu menu = new JMenu((String)this.getValue(NAME));
        boolean empty = true;
        GraphPropertyProvider n = context.lookup(GraphPropertyProvider.class);
        if(n!=null){
            for(String key : n.getKeys()){
                JMenuItem item = new JMenuItem(this);
                item.setText(key);
                item.putClientProperty("key", key);
                menu.add(item);
                empty = false;
            }
        }
        if(empty){
            JMenuItem item = new JMenuItem(bundle.getString("noproperties"));
            item.setEnabled(false);
            menu.add(item);
        }
        return menu;
    }
}
