/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.actions;

import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.Action;
import org.netbeans.api.actions.Openable;
import org.openide.filesystems.FileObject;
import org.openide.loaders.DataObject;
import org.openide.loaders.DataObjectNotFoundException;
import org.openide.util.ContextAwareAction;
import org.openide.util.Exceptions;
import org.openide.util.Lookup;
import org.openide.util.NbBundle;
import org.openide.util.Utilities;

public final class OpenSourceAction extends AbstractAction implements ContextAwareAction {
    
    private Lookup context;
    private Openable o;

    public void actionPerformed(ActionEvent e) {
       // TODO implement action body
        if(o!=null){
            o.open();
        }
    }

    public OpenSourceAction(){
        this(Utilities.actionsGlobalContext());
    }

    private OpenSourceAction(Lookup context){
        putValue(Action.NAME, NbBundle.getMessage(OpenSourceAction.class, "CTL_OpenSourceAction"));
        this.context = context;
        Lookup.Provider  n = context.lookup(Lookup.Provider.class);
        o = null;
        if(n!=null){
            Openable openable = n.getLookup().lookup(Openable.class);
            if(openable!=null){
                o = openable;
            } else {
                // No openable found, look for openable dataobject
                DataObject dataObject = n.getLookup().lookup(DataObject.class);
                if(dataObject!=null){
                    openable = dataObject.getLookup().lookup(Openable.class);
                    if(openable!=null){
                        o = openable;
                    }
                }
                if(o==null){
                    // Still nothing openable found, look for fileobject with openable dataobject behind
                    FileObject fileObject = n.getLookup().lookup(FileObject.class);
                    if(fileObject!=null){
                        try {
                            dataObject = DataObject.find(fileObject);
                            if(dataObject!=null){
                                openable = dataObject.getLookup().lookup(Openable.class);
                                if(openable!=null){
                                    o = openable;
                                }
                            }
                        } catch (DataObjectNotFoundException ex) {
                            Exceptions.printStackTrace(ex);
                        }
                    }
                }
            }
        }
        if(o==null){
            this.setEnabled(false);
        }
    }

    public Action createContextAwareInstance(Lookup actionContext) {
        return new OpenSourceAction(actionContext);
    }
}
