/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gpdv.core.implementation.actions;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import org.gpdv.core.api.abstractgraph.AbstractGraphEdge;
import org.gpdv.core.api.abstractgraph.AbstractGraphNode;
import org.openide.util.ContextAwareAction;
import org.openide.util.Lookup;
import org.openide.util.NbBundle;
import org.openide.util.Utilities;
import org.openide.util.actions.Presenter;

public final class RemoveEdgeAction extends AbstractAction implements ContextAwareAction, Presenter.Popup {

    private Lookup context;
    private ResourceBundle bundle;

    public RemoveEdgeAction(){
        this(Utilities.actionsGlobalContext());
    }

    private RemoveEdgeAction(Lookup context){
        putValue(Action.NAME, NbBundle.getMessage(RemoveNodeAction.class, "CTL_RemoveEdgeAction"));
        this.context = context;
        this.bundle = NbBundle.getBundle(RemoveEdgeAction.class);
    }

    public void actionPerformed(ActionEvent e) {
        // TODO implement action body
        Object o = e.getSource();
        if(o instanceof JMenuItem){
            JMenuItem i = (JMenuItem)o;
            AbstractGraphEdge edge = (AbstractGraphEdge) i.getClientProperty("edge");
            edge.getGraph().removeEdge(edge);
        }
    }

    public Action createContextAwareInstance(Lookup actionContext) {
        return new RemoveEdgeAction(actionContext);
    }

    public JMenuItem getPopupPresenter() {
        JMenu menu = new JMenu((String)this.getValue(NAME));
        AbstractGraphNode n = context.lookup(AbstractGraphNode.class);
        if(n!=null){
            JMenu incMenu = new JMenu(bundle.getString("incomingedges"));
            for(AbstractGraphEdge e : n.getIncomingEdges()){
                JMenuItem item = new JMenuItem(this);
//                item.setText(e.getName() + " from " + e.getSource().getName());
                item.setText(getDisplayString(e.getName(), bundle.getString("from"), e.getSource().getName()));
                item.putClientProperty("edge", e);
                incMenu.add(item);
            }
            if(incMenu.getItemCount()==0){
                JMenuItem item = new JMenuItem(bundle.getString("noincomingedges"));
                item.setEnabled(false);
                incMenu.add(item);
            }
            JMenu outMenu = new JMenu(bundle.getString("outgoingedges"));
            for(AbstractGraphEdge e : n.getOutgoingEdges()){
                JMenuItem item = new JMenuItem(this);
//                item.setText(e.getName() + " to " + e.getDestination().getName());
                item.setText(getDisplayString(e.getName(), bundle.getString("to"), e.getDestination().getName()));
                item.putClientProperty("edge", e);
                outMenu.add(item);
            }
            if(outMenu.getItemCount()==0){
                JMenuItem item = new JMenuItem(bundle.getString("nooutgoingedges"));
                item.setEnabled(false);
                outMenu.add(item);
            }
            menu.add(incMenu);
            menu.add(outMenu);
        }
        return menu;
    }

    private String getDisplayString(String source, String message, String destination){
        StringBuilder b = new StringBuilder();
        b.append(source);
        b.append(" ");
        b.append(message);
        b.append(" ");
        b.append(destination);
        return b.toString();
    }
}
