/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gpdv.core.implementation.actions;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Map;
import java.util.ResourceBundle;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import org.gpdv.core.api.abstractgraph.AbstractGraphNode;
import org.gpdv.core.api.abstractgraph.GraphPropertyProvider;
import org.openide.util.ContextAwareAction;
import org.openide.util.Lookup;
import org.openide.util.NbBundle;
import org.openide.util.Utilities;
import org.openide.util.actions.Presenter;

public final class RemovePropertyAction extends AbstractAction implements ContextAwareAction, Presenter.Popup {

    private Lookup context;
    private ResourceBundle bundle;

    public RemovePropertyAction(){
        this(Utilities.actionsGlobalContext());
    }

    private RemovePropertyAction(Lookup context){
        putValue(Action.NAME, NbBundle.getMessage(RemovePropertyAction.class, "CTL_RemovePropertyAction"));
        this.context = context;
        this.bundle = NbBundle.getBundle(RemovePropertyAction.class);
    }

    public void actionPerformed(ActionEvent e) {
        // TODO implement action body
        Object o = e.getSource();
        if(o instanceof JMenuItem){
            JMenuItem i = (JMenuItem)o;
            GraphPropertyProvider n = context.lookup(GraphPropertyProvider.class);
            if(n!=null){
                String key = (String) i.getClientProperty("key");
                if(key!=null){
                    n.removeProperty(key);
                }
            }
        }
    }

    public Action createContextAwareInstance(Lookup actionContext) {
        return new RemovePropertyAction(actionContext);
    }

    public JMenuItem getPopupPresenter() {
        JMenu menu = new JMenu((String)this.getValue(NAME));
        boolean empty = true;
        GraphPropertyProvider n = context.lookup(GraphPropertyProvider.class);
        if(n!=null){
            for(String key : n.getKeys()){
                JMenuItem item = new JMenuItem(this);
                item.setText(key);
                item.putClientProperty("key", key);
                menu.add(item);
                empty = false;
            }
        }
        if(empty){
            JMenuItem item = new JMenuItem(bundle.getString("noproperties"));
            item.setEnabled(false);
            menu.add(item);
        }
        return menu;
    }
}
