/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gpdv.core.implementation.globalactions;

import java.awt.Color;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import javax.swing.SwingUtilities;
import org.gpdv.services.GraphBuilder;
import org.gpdv.services.GraphLayouter;
import org.gpdv.core.api.abstractgraph.AbstractGraphEdge;
import org.gpdv.core.api.abstractgraph.AbstractGraph;
import org.gpdv.core.api.abstractgraph.AbstractGraphNode;
import org.gpdv.core.api.AbstractGraphFactory;
import org.gpdv.core.api.Visualizer;
import org.gpdv.core.implementation.scenes.TestRouter;
import org.gpdv.services.GraphDesigner;
import org.openide.modules.ModuleInfo;
import org.openide.util.Exceptions;
import org.openide.util.Lookup;
import org.openide.windows.IOProvider;
import org.openide.windows.OutputWriter;

public final class NewVisualizationAction implements ActionListener {

    AbstractGraph g;

    public void actionPerformed(ActionEvent e) {
//        final OutputWriter io = IOProvider.getDefault().getIO ("Visualizer", true).getOut();

        AbstractGraphFactory f = AbstractGraphFactory.getFactory();
//        io.println("Factory retrieved: "+f.toString());

        ModuleInfo mod = null;
        for(ModuleInfo info : Lookup.getDefault().lookupAll(ModuleInfo.class)){
            if(info.getCodeNameBase().equals("org.gpdv.core")){
                mod = info;
                break;
            }
        }

        GraphBuilder builder = null;
        Collection<GraphBuilder> c = Visualizer.Utils.getGraphBuildersForMimeType("netbeans/module");
        Iterator<GraphBuilder> it = c.iterator();
        while(builder==null&&it.hasNext()){
            GraphBuilder b = it.next();
            if(b.accepts(mod)) builder = b;
        }

        g = null;
        if(builder!=null){
            g = builder.buildGraph(mod);
        }
        if(g==null){
//            io.println("No Graph built");
        } else {
            Visualizer v = Visualizer.getVisualizer();
//            io.println("Visualizer retrieved: "+v.toString());
            v.visualize(v.getVisualizationRequest(g)
                    .setPreferredLayouter(Lookup.getDefault().lookup(GraphLayouter.class))
                    .setDesigners(new ArrayList<GraphDesigner>(Visualizer.Utils.getGraphDesignersForMimeType("java/class")))
                    .allowDifferentLayouter(true)
                    .allowRelayouting(true)
                    .allowToolbar(true)
                    .allowMovement(true)//);
                    .allowPins(true));
//            io.println("Visualization finished");
        }
    }
}
