/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.nodes;

import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.ResourceBundle;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import org.openide.util.ContextAwareAction;
import org.openide.util.ImageUtilities;
import org.openide.util.Lookup;
import org.openide.util.NbBundle;
import org.openide.util.lookup.Lookups;

/**
 *
 * @author odi
 */
public class ActionProvider {

    private static final String EDIT = "GraphActions/Edit/";
    private static final String OPEN = "GraphActions/Open/";
    private static final String PROPERTIES = "GraphActions/Properties/";
    private static final String EXTENSION = "GraphActions/Extension/";

    public static Action[] getActions(String s, Lookup.Provider provider){
        ResourceBundle bundle = NbBundle.getBundle(ActionProvider.class);
        Lookup lkp = Lookups.forPath(OPEN+s);
        Collection<? extends ContextAwareAction> actions = lkp.lookupAll(ContextAwareAction.class);
        List<Action> actionList = new ArrayList<Action>();
        for(ContextAwareAction a : actions){
            actionList.add(a.createContextAwareInstance(provider.getLookup()));
        }
        lkp = Lookups.forPath(EDIT+s);
        actions = lkp.lookupAll(ContextAwareAction.class);
        ActionWrapper myAction = new ActionWrapper(bundle.getString("edit"));
        for(ContextAwareAction a : actions){
            myAction.addAction(a.createContextAwareInstance(provider.getLookup()));
        }
        if(!actions.isEmpty()){
            actionList.add(null);
            actionList.add(myAction);
        }
        lkp = Lookups.forPath(PROPERTIES+s);
        actions = lkp.lookupAll(ContextAwareAction.class);
        myAction = new ActionWrapper(bundle.getString("properties"));
        myAction.setIcon(ImageUtilities.image2Icon(ImageUtilities.loadImage(bundle.getString("info"))));
        for(ContextAwareAction a : actions){
            myAction.addAction(a.createContextAwareInstance(provider.getLookup()));
        }
        if(!actions.isEmpty()){
            actionList.add(null);
            actionList.add(myAction);
        }
        lkp = Lookups.forPath(EXTENSION+s);
        actions = lkp.lookupAll(ContextAwareAction.class);
        if(!actions.isEmpty()) actionList.add(null);
        for(ContextAwareAction a : actions){
            actionList.add(a.createContextAwareInstance(provider.getLookup()));
        }

        return actionList.toArray(new Action[0]);
    }

}
