/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.nodes;

import java.util.ArrayList;
import java.util.List;
import org.gpdv.core.api.designgraph.DesignGraphEdge;
import org.gpdv.core.api.designgraph.DesignGraph;
import org.gpdv.core.api.designgraph.DesignGraphChangeEvent;
import org.gpdv.core.api.designgraph.DesignGraphChangeListener;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.util.WeakListeners;

/**
 *
 * @author odi
 */
class EdgeListChildren extends Children.Keys<DesignGraphEdge> implements DesignGraphChangeListener{

    private DesignGraph graph;
    private ArrayList<DesignGraphEdge> edgesList;

    public EdgeListChildren(DesignGraph graph) {
        this.graph = graph;
        this.edgesList = new ArrayList<DesignGraphEdge>();
        for(DesignGraphEdge e : graph.getDesignEdges()){
            edgesList.add(e);
        }
        graph.addDesignGraphChangeListener(WeakListeners.create(DesignGraphChangeListener.class, this, graph));
    }

    @Override
    protected void addNotify(){
        super.addNotify();
        setKeys(edgesList);
    }

    @Override
    protected Node[] createNodes(DesignGraphEdge edge) {
        return new Node[]{new EdgeNode(edge)};
    }

    public void designGraphChangePerformed(DesignGraphChangeEvent e) {
        if(e.getChangeString().equals(DesignGraphChangeEvent.EDGE_ADDED)||e.getChangeString().equals(DesignGraphChangeEvent.EDGE_REMOVED)){
            edgesList = new ArrayList<DesignGraphEdge>(graph.getDesignEdges());
            setKeys(edgesList);
            this.getGraphNode().fireGraphChangeEvent(new GraphChangeEvent(this.getNode()));
        }
    }

    public GraphNode getGraphNode(){
        Node n = this.getNode();
        while(n!=null){
            if(n instanceof GraphNode) return (GraphNode)n;
            n = n.getParentNode();
        }
        return null;
    }

}
