/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.nodes;

import java.awt.event.ActionEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Map;
import javax.swing.AbstractAction;
import javax.swing.Action;
import org.gpdv.core.api.designgraph.DesignGraphEdge;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.nodes.Sheet;
import org.openide.util.WeakListeners;
import org.openide.util.lookup.Lookups;
import org.openide.util.lookup.ProxyLookup;

/**
 *
 * @author odi
 */
public final class EdgeNode extends AbstractNode implements PropertyChangeListener{

    private DesignGraphEdge edge;

    public EdgeNode(DesignGraphEdge edge) {
//        super(new EdgeChildren(edge), Lookups.fixed(new Object[]{edge, edge.getAbstractEdge()}));
        super(Children.LEAF, new ProxyLookup(Lookups.fixed(new Object[]{edge, edge.getAbstractEdge()}), edge.getAbstractEdge().getLookup()));
        this.edge = edge;
        this.setName(edge.getName());
        edge.getAbstractEdge().addPropertyChangeListener(WeakListeners.propertyChange(this, edge.getAbstractEdge()));
    }

    public DesignGraphEdge getEdge(){
        return edge;
    }

    @Override
    public Action getPreferredAction() {
        Action[] actions = getActions(true);
        if(actions.length>0){
            return actions[0];
        } else {
            return new AbstractAction() {
                public void actionPerformed(ActionEvent e) {
                }
            };
        }
    }

    @Override
    public Action[] getActions(boolean context) {
        return ActionProvider.getActions("Edges", this);
    }

    public GraphNode getGraphNode(){
        Node n = this.getParentNode();
        while(n!=null){
            if(n instanceof GraphNode) return (GraphNode)n;
            n = n.getParentNode();
        }
        return null;
    }

    @Override
    protected Sheet createSheet() {
        Sheet sheet = Sheet.createDefault();
        Sheet.Set set = Sheet.createPropertiesSet();

        Map<String, String> properties = this.getEdge().getAbstractEdge().getProperties();
        for(String prop : properties.keySet()){
            set.put(new PropertyImpl(edge.getAbstractEdge(), prop, properties.get(prop)));
        }
        sheet.put(set);
        return sheet;
    }

    public void propertyChange(PropertyChangeEvent evt) {
        this.setSheet(this.createSheet());
    }
}
