/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.nodes;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import org.gpdv.core.api.designgraph.DesignGraphNode;
import org.gpdv.core.api.designgraph.DesignGraphNodeChangeEvent;
import org.gpdv.core.api.designgraph.DesignGraphNodeChangeListener;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.util.WeakListeners;

/**
 *
 * @author odi
 */
public final class NodeChildren extends Children.Keys<DesignGraphNode> implements DesignGraphNodeChangeListener{

    DesignGraphNode node;

    public NodeChildren(DesignGraphNode node) {
        this.node = node;
        node.addDesignGraphNodeChangeListener(WeakListeners.create(DesignGraphNodeChangeListener.class, this, node));
    }

    @Override
    protected void addNotify(){
        super.addNotify();
        List<DesignGraphNode> keys = new ArrayList<DesignGraphNode>();
        keys.add(node);
        setKeys(keys);
    }

    @Override
    protected Node[] createNodes(DesignGraphNode node) {
        return new Node[]{new SlotListNode(node.getIncomingSlots()), new SlotListNode(node.getOutgoingSlots())};
    }

    public void designNodeChangePerformed(DesignGraphNodeChangeEvent e) {
        if(!e.getChangeString().equals(DesignGraphNodeChangeEvent.NEW_DESIGN)){
            this.refreshKey(node);
            this.getGraphNode().fireGraphChangeEvent(new GraphChangeEvent(this.getNode()));
        }
    }

    public GraphNode getGraphNode(){
        Node n = this.getNode();
        while(n!=null){
            if(n instanceof GraphNode) return (GraphNode)n;
            n = n.getParentNode();
        }
        return null;
    }

}
