/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.nodes;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import org.gpdv.core.api.designgraph.DesignGraphEdge;
import org.gpdv.core.api.designgraph.DesignGraph;
import org.gpdv.core.api.designgraph.DesignGraphChangeEvent;
import org.gpdv.core.api.designgraph.DesignGraphChangeListener;
import org.gpdv.core.api.designgraph.DesignGraphNode;
import org.gpdv.core.api.designgraph.DesignGraphSlot;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.util.WeakListeners;

/**
 *
 * @author odi
 */
public final class NodeListChildren extends Children.Keys<DesignGraphNode> implements DesignGraphChangeListener{

    private DesignGraph graph;
    private ArrayList<DesignGraphNode> nodesList;

    public NodeListChildren(DesignGraph graph) {
        this.graph = graph;
        this.nodesList = new ArrayList<DesignGraphNode>();
        for(DesignGraphNode n : graph.getDesignNodes()){
            nodesList.add(n);
        }
        graph.addDesignGraphChangeListener(WeakListeners.create(DesignGraphChangeListener.class, this, graph));
    }

    @Override
    protected void addNotify(){
        super.addNotify();
        setKeys(nodesList);
    }

    @Override
    protected Node[] createNodes(DesignGraphNode node) {
        return new Node[]{new NodeNode(node)};
    }

    public void deleteFirstChild(){
        Iterator i = nodesList.iterator();
        if(i.hasNext()){
            DesignGraphNode dn = (DesignGraphNode) i.next();
            graph.getAbstractGraph().removeNode(dn.getAbstractNode());
        }
    }

    public void designGraphChangePerformed(DesignGraphChangeEvent e) {
        // not tested yet!
        if(e.getChangeString().equals(DesignGraphChangeEvent.NODE_ADDED)||e.getChangeString().equals(DesignGraphChangeEvent.NODE_REMOVED)){
            nodesList = new ArrayList<DesignGraphNode>(graph.getDesignNodes());
            setKeys(nodesList);
            this.getGraphNode().fireGraphChangeEvent(new GraphChangeEvent(this.getNode()));
        }
    }

    public GraphNode getGraphNode(){
        Node n = this.getNode();
        while(n!=null){
            if(n instanceof GraphNode) return (GraphNode)n;
            n = n.getParentNode();
        }
        return null;
    }

}
