/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.nodes;

import java.awt.event.ActionEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Map;
import javax.swing.AbstractAction;
import javax.swing.Action;
import org.gpdv.core.api.designgraph.DesignGraphNode;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.Node;
import org.openide.nodes.Sheet;
import org.openide.util.WeakListeners;
import org.openide.util.lookup.Lookups;
import org.openide.util.lookup.ProxyLookup;

/**
 *
 * @author odi
 */
public class NodeNode extends AbstractNode implements PropertyChangeListener{

//    private final String EDIT = "GraphActions/Edit/Nodes";
//    private final String OPEN = "GraphActions/Open/Nodes";
//    private final String PROPERTIES = "GraphActions/Properties/Nodes";
//    private final String EXTENSION = "GraphActions/Extension/Nodes";

    private DesignGraphNode node;

    NodeNode(DesignGraphNode node) {
        super(new NodeChildren(node), new ProxyLookup(Lookups.fixed(new Object[]{node, node.getAbstractNode()}), node.getAbstractNode().getLookup()));
        this.node = node;
        this.setName(node.getName());
        node.getAbstractNode().addPropertyChangeListener(WeakListeners.propertyChange(this, node.getAbstractNode()));
    }

    public DesignGraphNode getNode(){
        return node;
    }

    @Override
    public Action getPreferredAction() {
        Action[] actions = getActions(true);
        if(actions.length>0){
            return actions[0];
        } else {
            return new AbstractAction() {
                public void actionPerformed(ActionEvent e) {
                }
            };
        }
    }

    @Override
    public Action[] getActions(boolean context) {
        return ActionProvider.getActions("Nodes", this);
    }
   

    public GraphNode getGraphNode(){
        Node n = this.getParentNode();
        while(n!=null){
            if(n instanceof GraphNode) return (GraphNode)n;
            n = n.getParentNode();
        }
        return null;
    }

    @Override
    protected Sheet createSheet() {
        Sheet sheet = Sheet.createDefault();
        Sheet.Set set = Sheet.createPropertiesSet();

        Map<String, String> properties = this.getNode().getAbstractNode().getProperties();
        for(String prop : properties.keySet()){
            set.put(new PropertyImpl(node.getAbstractNode(), prop, properties.get(prop)));
        }
        sheet.put(set);
        return sheet;
    }

    public void propertyChange(PropertyChangeEvent evt) {
        this.setSheet(this.createSheet());
    }
}
