/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.nodes;

import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.Action;
import org.gpdv.core.api.designgraph.DesignGraphSlot;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.util.lookup.Lookups;

/**
 *
 * @author odi
 */
public final class SlotNode extends AbstractNode{

    private DesignGraphSlot slot;

    SlotNode(DesignGraphSlot slot) {
//        super(new SlotChildren(slot), Lookups.singleton(slot));
         super(Children.LEAF, Lookups.singleton(slot));
         StringBuilder b = new StringBuilder();
         b.append(slot.getDesignNode().getName());
         b.append(" Slot: ");
         int n = slot.getDesignNode().getIncomingSlots().indexOf(slot);
         if(n==-1) n = slot.getDesignNode().getOutgoingSlots().indexOf(slot);
         b.append(n);
         this.setName(b.toString());
         this.slot = slot;
    }

    public DesignGraphSlot getSlot(){
        return slot;
    }

    @Override
    public Action getPreferredAction() {
        Action[] actions = getActions(true);
        if(actions.length>0){
            return actions[0];
        } else {
            return new AbstractAction() {
                public void actionPerformed(ActionEvent e) {
                }
            };
        }
    }

//    @Override
//    public Action[] getActions(boolean context) {
//        return actions.toArray(new Action[0]);
//    }

    public NodeNode getNodeNode(){
        Node n = this.getParentNode();
        while(n!=null){
            if(n instanceof NodeNode) return (NodeNode)n;
            n = n.getParentNode();
        }
        return null;
    }
}
