/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.scenes;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.util.Collection;
import javax.swing.AbstractAction;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JViewport;
import org.gpdv.core.implementation.nodes.EdgeNode;
import org.gpdv.core.implementation.nodes.NodeNode;
import org.netbeans.api.visual.action.PopupMenuProvider;
import org.netbeans.api.visual.action.SelectProvider;
import org.netbeans.api.visual.graph.GraphPinScene;
import org.netbeans.api.visual.graph.GraphScene;
import org.netbeans.api.visual.model.ObjectScene;
import org.netbeans.api.visual.widget.Widget;
import org.openide.nodes.Node;

/**
 *
 * @author odi
 */
public class ScenePopupMenuProvider implements PopupMenuProvider{

    private GraphSceneInterface scene;
    private JScrollPane scrollPane;
    private SelectProvider selectProvider;
    private Node graph;

    public ScenePopupMenuProvider(GraphSceneInterface scene, JScrollPane scrollPane, SelectProvider selectProvider){
        this.scene = scene;
        this.scrollPane = scrollPane;
        this.selectProvider = selectProvider;
    }

    public void setGraph(Node graph){
        this.graph = graph;
    }

    public JPopupMenu getPopupMenu(Widget widget, Point localLocation) {
        JPopupMenu popup;
        if(graph!=null){
            popup = graph.getContextMenu();
        } else {
            popup = new JPopupMenu();
        }
        addGotoSelection(popup);
        addUnselectObject(popup);
        return popup;
    }

    private void addGotoSelection(JPopupMenu popup){
        JMenuItem item = new JMenuItem(new AbstractAction("Go to selection") {
            public void actionPerformed(ActionEvent e) {
                scene.focusSelectedObject();
            }
        });
        if(scene.getObjectScene().getSelectedObjects().isEmpty()) item.setEnabled(false);
        popup.add(item, 0);
    }

    private void addUnselectObject(JPopupMenu popup) {
        JMenuItem item = new JMenuItem(new AbstractAction("Clear selection") {
            public void actionPerformed(ActionEvent e) {
                selectProvider.select(scene.getObjectScene(), null, false);
            }
        });
        if(scene.getObjectScene().getSelectedObjects().isEmpty()) item.setEnabled(false);
        popup.add(item, 1);
    }
}
