/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.views;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.util.ResourceBundle;
import javax.swing.AbstractAction;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JToolBar;
import javax.swing.ListCellRenderer;
import org.gpdv.services.GraphDesigner;
import org.gpdv.services.GraphLayouter;
import org.gpdv.core.api.VisualizationRequest;
import org.gpdv.services.GraphRouter;
import org.openide.util.ImageUtilities;
import org.openide.util.NbBundle;

/**
 *
 * @author odi
 */
public class MyToolBar extends JToolBar{

//    private GraphLayouter layouter;
//    private GraphRouter router;

    public MyToolBar(final VisualizationRequest request, final VisualizationManagementPanel panel) {
        super(panel.getName());
        ResourceBundle bundle = NbBundle.getBundle(MyToolBar.class);
//        this.layouter = Lookup.getDefault().lookup(GraphLayouter.class);
//        this.router = new TestRouter();
        if(request.allowResetLayout()&&request.allowMovement())this.add(new AbstractAction(bundle.getString("resetpositions")) {
            public void actionPerformed(ActionEvent e) {
                panel.resetLayout();
            }
        });
        if(request.allowRelayouting())this.add(new AbstractAction("Run Layouter", ImageUtilities.image2Icon(ImageUtilities.loadImage(bundle.getString("refresh")))) {
            public void actionPerformed(ActionEvent e) {
                panel.enforceLayout();
            }
        });
        if(request.allowDifferentDesigner()){
            final JComboBox box = new JComboBox(panel.getAvailableGraphDesigners().toArray());
            box.setSelectedItem(panel.getSelectedDesigner());
            box.setAction(new AbstractAction() {
                public void actionPerformed(ActionEvent e) {
                    GraphDesigner d = (GraphDesigner) box.getSelectedItem();
                    panel.setGraphDesigner(d);
                }
            });
            this.addSeparator();
            box.setRenderer(new DesignerRenderer());
            box.setMinimumSize(new Dimension(250,20));
            box.setMaximumSize(new Dimension(500,100));
            this.add(new JLabel(getString(bundle.getString("designer"))));
            this.add(box);
        }
        if(request.allowDifferentLayouter()){
            final JComboBox box = new JComboBox(panel.getAvailableGraphLayouters().toArray());
            box.setSelectedItem(panel.getSelectedLayouter());
            box.setAction(new AbstractAction() {
                public void actionPerformed(ActionEvent e) {
                    GraphLayouter l = (GraphLayouter) box.getSelectedItem();
                    panel.setGraphLayouter(l);
                }
            });
            this.addSeparator();
            box.setMinimumSize(new Dimension(250,20));
            box.setMaximumSize(new Dimension(500,100));
            box.setRenderer(new LayouterRenderer());
            this.add(new JLabel(getString(bundle.getString("layouter"))));
            this.add(box);
        }
        if(request.allowDifferentRouter()){
            final JComboBox box = new JComboBox(panel.getAvailableRouters().toArray());
            box.setAction(new AbstractAction() {
                public void actionPerformed(ActionEvent e) {
                    GraphRouter l = (GraphRouter) box.getSelectedItem();
                    panel.setRouter(l);
                }
            });
            this.addSeparator();
            box.setMinimumSize(new Dimension(250,20));
            box.setMaximumSize(new Dimension(500,100));
            box.setRenderer(new RouterRenderer());
            this.add(new JLabel(getString(bundle.getString("router"))));
            this.add(box);
        }
    }

    private class DesignerRenderer extends JLabel implements ListCellRenderer {
        public DesignerRenderer() {
            setOpaque(true);
            setHorizontalAlignment(LEFT);
            setVerticalAlignment(CENTER);
        }
        public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
            if (isSelected) {
                setBackground(list.getSelectionBackground());
                setForeground(list.getSelectionForeground());
            } else {
                setBackground(list.getBackground());
                setForeground(list.getForeground());
            }
            setText(((GraphDesigner)value).getRepresentation().getDisplayName());
            setFont(list.getFont());
            this.setToolTipText(((GraphDesigner)value).getRepresentation().getShortDescription());
            return this;
        }
    }

    private class LayouterRenderer extends JLabel implements ListCellRenderer {
        public LayouterRenderer() {
            setOpaque(true);
            setHorizontalAlignment(LEFT);
            setVerticalAlignment(CENTER);
        }
        public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
            if (isSelected) {
                setBackground(list.getSelectionBackground());
                setForeground(list.getSelectionForeground());
            } else {
                setBackground(list.getBackground());
                setForeground(list.getForeground());
            }
            setText(((GraphLayouter)value).getRepresentation().getDisplayName());
            setFont(list.getFont());
            this.setToolTipText(((GraphLayouter)value).getRepresentation().getShortDescription());
            return this;
        }
    }

    private class RouterRenderer extends JLabel implements ListCellRenderer {
        public RouterRenderer() {
            setOpaque(true);
            setHorizontalAlignment(LEFT);
            setVerticalAlignment(CENTER);
        }
        public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
            if (isSelected) {
                setBackground(list.getSelectionBackground());
                setForeground(list.getSelectionForeground());
            } else {
                setBackground(list.getBackground());
                setForeground(list.getForeground());
            }
            setText(((GraphRouter)value).getRepresentation().getDisplayName());
            setFont(list.getFont());
            this.setToolTipText(((GraphRouter)value).getRepresentation().getShortDescription());
            return this;
        }
    }

    private String getString(String message){
        StringBuilder b = new StringBuilder(message);
        b.append(" ");
        return b.toString();
    }
}
