/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.widgets;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Stroke;
import org.gpdv.core.implementation.nodes.EdgeNode;
import org.gpdv.core.implementation.nodes.NodeNode;
import org.netbeans.api.visual.anchor.AnchorShape;
import org.netbeans.api.visual.model.ObjectState;
import org.netbeans.api.visual.router.RouterFactory;
import org.netbeans.api.visual.widget.ConnectionWidget;
import org.netbeans.api.visual.widget.LayerWidget;
import org.netbeans.api.visual.widget.Scene;
import org.openide.nodes.Node;

/**
 *
 * @author odi
 */
public class EdgeWidget extends ConnectionWidget {

    private EdgeNode edge;
    private Stroke defaultStroke;

    public EdgeWidget(EdgeNode edge, Scene scene, LayerWidget layer) {
        super(scene);
        this.edge = edge;
//        this.setControlPoints(edge.getEdge().getControlPoints(), true);
        this.setRoutingPolicy(ConnectionWidget.RoutingPolicy.ALWAYS_ROUTE);
        this.defaultStroke = this.getStroke();
        this.setLineColor(edge.getEdge().getDesign().getDefaultColor());
    }

    public EdgeNode getEdge(){
        return edge;
    }

    @Override
    public void notifyStateChanged(ObjectState previousState, ObjectState state) {
        super.notifyStateChanged(previousState, state);
        if(state.isSelected()){
            if(!previousState.isSelected()){
                this.setLineColor(edge.getEdge().getDesign().getSelectedColor());
                this.setStroke(new BasicStroke(3, BasicStroke.CAP_ROUND, BasicStroke.JOIN_BEVEL));
                this.getScene().revalidate();
            }
        } else if(state.isHovered()){
            if(!previousState.isHovered()){
                this.getSourceAnchor().getRelatedWidget().bringToFront();
                this.getTargetAnchor().getRelatedWidget().bringToFront();
                this.setLineColor(edge.getEdge().getDesign().getHoveredColor());
                this.setStroke(new BasicStroke(3, BasicStroke.CAP_ROUND, BasicStroke.JOIN_BEVEL));
                this.getScene().revalidate();
            }
        } else {
            if(!this.getLineColor().equals(edge.getEdge().getDesign().getDefaultColor())){
                this.setLineColor(edge.getEdge().getDesign().getDefaultColor());
                this.setStroke(defaultStroke);
                this.getScene().revalidate();
            }
        }
    }



}
