/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.widgets;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Rectangle;
import org.gpdv.core.api.designgraph.Design;
import org.gpdv.core.implementation.nodes.NodeNode;
import org.gpdv.core.implementation.nodes.SlotNode;
import org.netbeans.api.visual.border.BorderFactory;
import org.netbeans.api.visual.layout.LayoutFactory;
import org.netbeans.api.visual.model.ObjectState;
import org.netbeans.api.visual.widget.ImageWidget;
import org.netbeans.api.visual.widget.Scene;
import org.netbeans.api.visual.widget.Widget;

/**
 *
 * @author odi
 */
public class ImageSlotWidget extends Widget implements SlotWidgetInterface{

    private SlotNode slot;
    private NodeNode node;
    private Design design;

    private ImageWidget imageWidget;

    private boolean minimized;

    private Point move;

    public ImageSlotWidget(NodeNode node, SlotNode pin, Scene scene) {
        super(scene);
        setLayout(LayoutFactory.createAbsoluteLayout());
        imageWidget = new ImageWidget(scene);
        imageWidget.setImage(pin.getSlot().getDesign().getImage());
        this.addChild(imageWidget);
        this.minimized = false;
        this.slot = pin;
        this.node = node;
        this.design = slot.getSlot().getDesign();
        this.setPreferredLocation(slot.getSlot().getPoint());
        this.setPreferredBounds(new Rectangle(0,0,slot.getSlot().getWidth(), slot.getSlot().getHeight()));
        this.setPreferredSize(new Dimension(slot.getSlot().getWidth(), slot.getSlot().getHeight()));
        this.setOpaque(true);
//        this.setBackground(slot.getSlot().getDesign().getDefaultColor());
//        this.setBorder(BorderFactory.createRoundedBorder(design.getArcWidth(), design.getArcHeight(), design.getDefaultColor(), design.getDefaultBorderColor()));
    }

    @Override
    public void notifyStateChanged(ObjectState previousState, ObjectState state) {
        super.notifyStateChanged(previousState, state);
        if(state.isSelected()){
//            labelWidget.setBackground(node.getNode().getDesign().getSelectedColor());
            this.setOpaque(minimized);
            this.bringToFront();
            if(!minimized)this.setPreferredBounds(new Rectangle(-design.getSelectionSizeIncreaseHorizontal(),-design.getSelectionSizeInncreaseVertical(), design.getWidth()+2*design.getSelectionSizeIncreaseHorizontal(), design.getHeight()+2*design.getSelectionSizeInncreaseVertical()));
            if(!minimized){
                this.setBorder(BorderFactory.createRoundedBorder(10, 10, design.getIncreasedBackgroundColor(), Color.black));
            } else {
                this.setBorder(BorderFactory.createRoundedBorder(10, 10, design.getSelectedColor(), design.getSelectedBorderColor()));
            }
//            this.setForeground(Color.WHITE);
//            this.setFont(this.getFont().deriveFont(Font.BOLD));
        } else if(state.isHovered()){
//            labelWidget.setBackground(node.getNode().getDesign().getHoveredColor());
            this.setOpaque(true);
            this.bringToFront();
//            this.setBackground(Color.lightGray);
//            this.setPreferredBounds(new Rectangle(-2,-2, node.getNode().getWidth()+4, node.getNode().getHeight()+4));
//            this.setBorder(BorderFactory.createBevelBorder(true, Color.black));
            // TODO: ADD DESIGNINFORMATION ON IMAGE HOVER AND SELECTED BACKGROUND COLORS AND SIZE-INCREASE
            if(!minimized)this.setPreferredBounds(new Rectangle(-design.getSelectionSizeIncreaseHorizontal(),-design.getSelectionSizeInncreaseVertical(), design.getWidth()+2*design.getSelectionSizeIncreaseHorizontal(), design.getHeight()+2*design.getSelectionSizeInncreaseVertical()));
            if(!minimized){
                this.setBorder(BorderFactory.createRoundedBorder(10, 10, design.getIncreasedBackgroundColor(), Color.black));
            } else {
                this.setBorder(BorderFactory.createRoundedBorder(10, 10, design.getHoveredColor(), design.getHoveredBorderColor()));
            }
//            this.setForeground(Color.YELLOW);
//            this.setFont(this.getFont().deriveFont(Font.ITALIC));
        } else {
//            if(this.labelWidget==null||this.node==null) return;
//            labelWidget.setBackground(node.getNode().getDesign().getDefaultColor());
            this.setOpaque(minimized);
            if(!minimized)this.setPreferredBounds(new Rectangle(0, 0, design.getWidth(), design.getHeight()));
            if(!minimized){
                this.setBorder(BorderFactory.createEmptyBorder());
            } else {
                this.setBorder(BorderFactory.createRoundedBorder(10, 10, design.getDefaultColor(), design.getDefaultBorderColor()));
            }
//            this.setForeground(Color.BLACK);
//            this.setFont(this.getFont().deriveFont(Font.PLAIN));
        }
    }

    public NodeNode getNode() {
        return node;
    }

    public void minimize(Point p){
        int moveX = p.x - this.getPreferredLocation().x;
        int moveY = p.y - this.getPreferredLocation().y;
        move = new Point(moveX, moveY);
        this.setPreferredLocation(p);
        this.setPreferredBounds(new Rectangle(0, 0, 0, 0));
        this.removeChild(imageWidget);
        this.minimized = true;
        this.revalidate();
    }

    public void restore(){
        int x = this.getPreferredLocation().x - move.x;
        int y = this.getPreferredLocation().y - move.y;
        this.setPreferredLocation(new Point(x, y));
        this.setPreferredBounds(new Rectangle(0, 0, slot.getSlot().getWidth(), slot.getSlot().getHeight()));
        this.addChild(imageWidget);
        this.minimized = false;
        this.revalidate();
    }

    public SlotNode getSlotNode() {
        return slot;
    }

}
