/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.implementation.widgets;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Rectangle;
import org.gpdv.core.api.designgraph.Design;
import org.gpdv.core.implementation.nodes.NodeNode;
import org.gpdv.core.implementation.nodes.SlotNode;
import org.netbeans.api.visual.border.BorderFactory;
import org.netbeans.api.visual.model.ObjectState;
import org.netbeans.api.visual.widget.LabelWidget;
import org.netbeans.api.visual.widget.Scene;

/**
 *
 * @author odi
 */
public class SlotWidget extends LabelWidget implements SlotWidgetInterface{

    private SlotNode slot;
    private NodeNode node;
    private Design design;

    private Point move;

    public SlotWidget(NodeNode node, SlotNode pin, Scene scene) {
        super(scene);
        this.slot = pin;
        this.node = node;
        this.design = slot.getSlot().getDesign();
        this.setPreferredLocation(slot.getSlot().getPoint());
        this.setPreferredBounds(new Rectangle(0,0,slot.getSlot().getWidth(), slot.getSlot().getHeight()));
        this.setPreferredSize(new Dimension(slot.getSlot().getWidth(), slot.getSlot().getHeight()));
        this.setOpaque(true);
//        this.setBackground(slot.getSlot().getDesign().getDefaultColor());
        this.setBorder(BorderFactory.createRoundedBorder(design.getArcWidth(), design.getArcHeight(), design.getDefaultColor(), design.getDefaultBorderColor()));
    }

    @Override
    public void notifyStateChanged(ObjectState previousState, ObjectState state) {
        super.notifyStateChanged(previousState, state);
        if(state.isSelected()){
//            this.setBackground(slot.getSlot().getDesign().getSelectedColor());
            this.setBorder(BorderFactory.createRoundedBorder(design.getArcWidth(), design.getArcHeight(), design.getSelectedColor(), design.getSelectedBorderColor()));
        } else if(state.isHovered()){
//            this.setBackground(slot.getSlot().getDesign().getHoveredColor());
            this.setBorder(BorderFactory.createRoundedBorder(design.getArcWidth(), design.getArcHeight(), design.getHoveredColor(), design.getHoveredBorderColor()));
        } else {
//            this.setBackground(slot.getSlot().getDesign().getDefaultColor());
            this.setBorder(BorderFactory.createRoundedBorder(design.getArcWidth(), design.getArcHeight(), design.getDefaultColor(), design.getDefaultBorderColor()));
        }
    }

    public NodeNode getNode() {
        return node;
    }

    public void minimize(Point p){
        int moveX = p.x - this.getPreferredLocation().x;
        int moveY = p.y - this.getPreferredLocation().y;
        move = new Point(moveX, moveY);
        this.setPreferredLocation(p);
        this.setPreferredBounds(new Rectangle(0, 0, 0, 0));
    }

    public void restore(){
        int x = this.getPreferredLocation().x - move.x;
        int y = this.getPreferredLocation().y - move.y;
        this.setPreferredLocation(new Point(x, y));
        this.setPreferredBounds(new Rectangle(0, 0, slot.getSlot().getWidth(), slot.getSlot().getHeight()));
    }

    public SlotNode getSlotNode() {
        return slot;
    }

}
