/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.abstractgraph;

import org.gpdv.core.api.abstractgraph.AbstractGraphEdgeChangeEvent;
import org.gpdv.core.api.abstractgraph.AbstractGraphEdge;
import org.gpdv.core.api.abstractgraph.AbstractGraphNode;
import org.gpdv.core.api.abstractgraph.AbstractGraph;
import java.util.HashMap;
import java.util.Map;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import org.openide.util.Exceptions;
import static org.junit.Assert.*;

/**
 *
 * @author odi
 */
public class AbstractEdgeChangeEventTest {

    private AbstractGraphEdgeChangeEvent event1;
    private AbstractGraphEdgeChangeEvent event2;
    private AbstractGraphEdgeChangeEvent event3;
    private AbstractGraph g;
    private AbstractGraphNode n1;
    private AbstractGraphNode n2;
    private AbstractGraphEdge e;
    private String testKey;
    private String testValue;

    public AbstractEdgeChangeEventTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
        g = new AbstractGraph(1L, "TestGraph", null);
        n1 = new AbstractGraphNode(2L, "TestNode", g, null);
        n2 = new AbstractGraphNode(3L, "TestNode2", g, null);
        e = new AbstractGraphEdge(4L, "TestEdge", g, n1, n2, null);
        Map<String, String> map = new HashMap<String, String>();
        testKey = "testKey";
        testValue = "testValue";
        map.put(testKey, testValue);
        event1 = new AbstractGraphEdgeChangeEvent(e, AbstractGraphEdgeChangeEvent.NEW_DESTINATION, n2, null);
        event2 = new AbstractGraphEdgeChangeEvent(e, AbstractGraphEdgeChangeEvent.NEW_SOURCE, n1, null);
        event3 = new AbstractGraphEdgeChangeEvent(e, AbstractGraphEdgeChangeEvent.NEW_PROPERTIES, null, map);
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of getChangeString method, of class AbstractGraphEdgeChangeEvent.
     */
    @Test
    public void testGetChangeString() {
        System.out.println("getChangeString");
        assertEquals(event1.getChangeString(), AbstractGraphEdgeChangeEvent.NEW_DESTINATION);
        assertEquals(event2.getChangeString(), AbstractGraphEdgeChangeEvent.NEW_SOURCE);
        assertEquals(event3.getChangeString(), AbstractGraphEdgeChangeEvent.NEW_PROPERTIES);
    }

    /**
     * Test of getEdge method, of class AbstractGraphEdgeChangeEvent.
     */
    @Test
    public void testGetEdge() {
        System.out.println("getEdge");
        assertEquals(event1.getEdge(), e);
        assertEquals(event2.getEdge(), e);
        assertEquals(event3.getEdge(), e);
    }

    /**
     * Test of getOldNode method, of class AbstractGraphEdgeChangeEvent.
     */
    @Test
    public void testGetOldNode() {
        System.out.println("getOldNode");
        assertEquals(event1.getOldNode(), n2);
        assertEquals(event2.getOldNode(), n1);
        assertNull(event3.getOldNode());
    }

    /**
     * Test of getChangedProperties method, of class AbstractGraphEdgeChangeEvent.
     */
    @Test
    public void testGetChangedProperties() {
        System.out.println("getChangedProperties");
        assertNull(event1.getChangedProperties());
        assertNull(event2.getChangedProperties());
        assertTrue(event3.getChangedProperties().size()==1);
        assertTrue(event3.getChangedProperties().containsKey(testKey));
        assertEquals(event3.getChangedProperties().get(testKey), testValue);
    }

}