/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.abstractgraph;

import org.gpdv.core.api.abstractgraph.AbstractGraphEdge;
import org.gpdv.core.api.abstractgraph.AbstractGraphChangeEvent;
import org.gpdv.core.api.abstractgraph.AbstractGraphNode;
import org.gpdv.core.api.abstractgraph.AbstractGraph;
import java.util.HashMap;
import java.util.Map;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author odi
 */
public class AbstractGraphChangeEventTest {

    private AbstractGraphChangeEvent event1;
    private AbstractGraphChangeEvent event2;
    private AbstractGraphChangeEvent event3;
    private AbstractGraph g;
    private AbstractGraphNode n1;
    private AbstractGraphNode n2;
    private AbstractGraphEdge e;
    private String testKey;
    private String testValue;

    public AbstractGraphChangeEventTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
        g = new AbstractGraph(1L, "TestGraph", null);
        n1 = new AbstractGraphNode(2L, "TestNode", g, null);
        n2 = new AbstractGraphNode(3L, "TestNode2", g, null);
        e = new AbstractGraphEdge(4L, "TestEdge", g, n1, n2, null);
        Map<String, String> map = new HashMap<String, String>();
        testKey = "testKey";
        testValue = "testValue";
        map.put(testKey, testValue);
        event1 = new AbstractGraphChangeEvent(g, AbstractGraphChangeEvent.NODE_ADDED, n1, null, null);
        event2 = new AbstractGraphChangeEvent(g, AbstractGraphChangeEvent.EDGE_ADDED, null, e, null);
        event3 = new AbstractGraphChangeEvent(g, AbstractGraphChangeEvent.NEW_PROPERTIES, null, null, map);
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of getChangeString method, of class AbstractGraphChangeEvent.
     */
    @Test
    public void testGetChangeString() {
        System.out.println("getChangeString");
        assertEquals(event1.getChangeString(), AbstractGraphChangeEvent.NODE_ADDED);
        assertEquals(event2.getChangeString(), AbstractGraphChangeEvent.EDGE_ADDED);
        assertEquals(event3.getChangeString(), AbstractGraphChangeEvent.NEW_PROPERTIES);
    }

    /**
     * Test of getGraph method, of class AbstractGraphChangeEvent.
     */
    @Test
    public void testGetGraph() {
        System.out.println("getGraph");
        assertEquals(event1.getGraph(), g);
        assertEquals(event2.getGraph(), g);
        assertEquals(event3.getGraph(), g);
    }

    /**
     * Test of getChangedNode method, of class AbstractGraphChangeEvent.
     */
    @Test
    public void testGetChangedNode() {
        System.out.println("getChangedNode");
        assertEquals(event1.getChangedNode(), n1);
        assertNull(event2.getChangedNode());
        assertNull(event3.getChangedNode());
    }

    /**
     * Test of getChangedEdge method, of class AbstractGraphChangeEvent.
     */
    @Test
    public void testGetChangedEdge() {
        System.out.println("getChangedEdge");
        assertNull(event1.getChangedEdge());
        assertEquals(event2.getChangedEdge(), e);
        assertNull(event3.getChangedEdge());
    }

    /**
     * Test of getChangedProperties method, of class AbstractGraphChangeEvent.
     */
    @Test
    public void testGetChangedProperties() {
        System.out.println("getChangedProperties");
        assertNull(event1.getChangedProperties());
        assertNull(event2.getChangedProperties());
        assertTrue(event3.getChangedProperties().size()==1);
        assertTrue(event3.getChangedProperties().containsKey(testKey));
        assertEquals(event3.getChangedProperties().get(testKey), testValue);
    }

}