/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.abstractgraph;

import org.gpdv.core.api.abstractgraph.AbstractGraphNodeChangeEvent;
import org.gpdv.core.api.abstractgraph.AbstractGraphEdge;
import org.gpdv.core.api.abstractgraph.AbstractGraphNode;
import org.gpdv.core.api.abstractgraph.AbstractGraph;
import java.util.HashMap;
import java.util.Map;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author odi
 */
public class AbstractNodeChangeEventTest {

    private AbstractGraphNodeChangeEvent event1;
    private AbstractGraphNodeChangeEvent event2;
    private AbstractGraph g;
    private AbstractGraphNode n1;
    private AbstractGraphNode n2;
    private AbstractGraphEdge e;
    private String testKey;
    private String testValue;

    public AbstractNodeChangeEventTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
        g = new AbstractGraph(1L, "TestGraph", null);
        n1 = new AbstractGraphNode(2L, "TestNode", g, null);
        n2 = new AbstractGraphNode(3L, "TestNode2", g, null);
        e = new AbstractGraphEdge(4L, "TestEdge", g, n1, n2, null);
        Map<String, String> map = new HashMap<String, String>();
        testKey = "testKey";
        testValue = "testValue";
        map.put(testKey, testValue);
        event1 = new AbstractGraphNodeChangeEvent(n1, AbstractGraphNodeChangeEvent.INCOMING_EDGE_ADDED, e, null);
        event2 = new AbstractGraphNodeChangeEvent(n2, AbstractGraphNodeChangeEvent.NEW_PROPERTIES, null, map);
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of getNode method, of class AbstractGraphNodeChangeEvent.
     */
    @Test
    public void testGetNode() {
        System.out.println("getNode");
        assertEquals(event1.getNode(), n1);
        assertEquals(event2.getNode(), n2);
    }

    /**
     * Test of getChangeString method, of class AbstractGraphNodeChangeEvent.
     */
    @Test
    public void testGetChangeString() {
        System.out.println("getChangeString");
        assertEquals(event1.getChangeString(), AbstractGraphNodeChangeEvent.INCOMING_EDGE_ADDED);
        assertEquals(event2.getChangeString(), AbstractGraphNodeChangeEvent.NEW_PROPERTIES);
    }

    /**
     * Test of getChangedEdge method, of class AbstractGraphNodeChangeEvent.
     */
    @Test
    public void testGetChangedEdge() {
        System.out.println("getChangedEdge");
        assertEquals(event1.getChangedEdge(), e);
        assertNull(event2.getChangedEdge());
    }

    /**
     * Test of getChangedProperties method, of class AbstractGraphNodeChangeEvent.
     */
    @Test
    public void testGetChangedProperties() {
        System.out.println("getChangedProperties");
        assertNull(event1.getChangedProperties());
        assertTrue(event2.getChangedProperties().size()==1);
        assertTrue(event2.getChangedProperties().containsKey(testKey));
        assertEquals(event2.getChangedProperties().get(testKey), testValue);
    }

}