/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.core.api.abstractgraph;

import org.gpdv.core.api.abstractgraph.AbstractGraphEdge;
import org.gpdv.core.api.abstractgraph.AbstractGraphNode;
import org.gpdv.core.api.abstractgraph.AbstractGraph;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;
import org.openide.util.Lookup;

/**
 *
 * @author odi
 */
public class AbstractNodeTest {

    private AbstractGraph g1, g2;
    private AbstractGraphNode n1, n2, n3, n4;
    private AbstractGraphEdge e;
    private String name;
    private long id;


    public AbstractNodeTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
        id = 3L;
        name = "TestNode1";
        g1 = new AbstractGraph(1L, "TestGraph1", null);
        g2 = new AbstractGraph(2L, "TestGraph2", null);
        n1 = new AbstractGraphNode(id, name, g1, g1);
        n2 = new AbstractGraphNode(4L, "TestNode2", g1, g1);
        n3 = new AbstractGraphNode(5L, "TestNode3", g2, g2);
        n4 = new AbstractGraphNode(6L, "TestNode4", g2, g2);
        e = new AbstractGraphEdge(7L, "TestEdge1", g1, n1, n2, null);
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of getGraph method, of class AbstractGraphNode.
     */
    @Test
    public void testGetGraph() {
        System.out.println("getGraph");
        assertEquals(n1.getGraph(), g1);
        assertEquals(n3.getGraph(), g2);
    }

    /**
     * Test of getID method, of class AbstractGraphNode.
     */
    @Test
    public void testGetID() {
        System.out.println("getID");
        assertEquals(n1.getID(), id);
    }

    /**
     * Test of getName method, of class AbstractGraphNode.
     */
    @Test
    public void testGetName() {
        System.out.println("getName");
        assertEquals(n1.getName(), name);
    }

    /**
     * Test of getLookup method, of class AbstractGraphNode.
     */
    @Test
    public void testGetLookup() {
        System.out.println("getLookup");
        Lookup lookup = n1.getLookup();
        assertNotNull(lookup);
        AbstractGraph graph = lookup.lookup(AbstractGraph.class);
        assertNotNull(graph);
    }

    /**
     * Test of getIncomingEdges method, of class AbstractGraphNode.
     */
    @Test
    public void testGetIncomingEdges() {
        System.out.println("getIncomingEdges");
        assertTrue(n1.getIncomingEdges().isEmpty());
        assertTrue(n2.getIncomingEdges().contains(e));
        assertTrue(n3.getIncomingEdges().isEmpty());
    }

    /**
     * Test of getOutgoingEdges method, of class AbstractGraphNode.
     */
    @Test
    public void testGetOutgoingEdges() {
        System.out.println("getOutgoingEdges");
        assertTrue(n1.getOutgoingEdges().contains(e));
        assertTrue(n2.getOutgoingEdges().isEmpty());
        assertTrue(n3.getOutgoingEdges().isEmpty());
    }

    /**
     * Test of addIncomingEdge method, of class AbstractGraphNode.
     */
    @Test
    public void testAddIncomingEdge() {
        assertTrue(n1.getIncomingEdges().isEmpty());
        e.setDestination(n1);
        assertTrue(n1.getIncomingEdges().contains(e));
    }

    /**
     * Test of addOutgoingEdge method, of class AbstractGraphNode.
     */
    @Test
    public void testAddOutgoingEdge() {
        System.out.println("addOutgoingEdge");
        assertTrue(n2.getOutgoingEdges().isEmpty());
        e.setSource(n2);
        assertTrue(n2.getOutgoingEdges().contains(e));
    }

    /**
     * Test of removeIncomingEdge method, of class AbstractGraphNode.
     */
    @Test
    public void testRemoveIncomingEdge() {
        System.out.println("removeIncomingEdge");
        e.setDestination(n1);
        assertTrue(n1.getIncomingEdges().contains(e));
        e.setDestination(n2);
        assertTrue(n1.getIncomingEdges().isEmpty());
    }

    /**
     * Test of removeOutgoingEdge method, of class AbstractGraphNode.
     */
    @Test
    public void testRemoveOutgoingEdge() {
        System.out.println("removeOutgoingEdge");
        e.setSource(n2);
        assertTrue(n2.getOutgoingEdges().contains(e));
        e.setSource(n1);
        assertTrue(n2.getOutgoingEdges().isEmpty());
    }

    /**
     * Test of addAbstractNodeChangeListener method, of class AbstractGraphNode.
     */
    @Test
    public void testAddAbstractNodeChangeListener() {
    }

    /**
     * Test of removeAbstractNodeChangeListener method, of class AbstractGraphNode.
     */
    @Test
    public void testRemoveAbstractNodeChangeListener() {
    }

    /**
     * Test of getProperties method, of class AbstractGraphNode.
     */
    @Test
    public void testGetProperties() {
    }

    /**
     * Test of addProperty method, of class AbstractGraphNode.
     */
    @Test
    public void testAddProperty() {
    }

    /**
     * Test of removeProperty method, of class AbstractGraphNode.
     */
    @Test
    public void testRemoveProperty() {
    }

    /**
     * Test of setProperties method, of class AbstractGraphNode.
     */
    @Test
    public void testSetProperties() {
    }

    /**
     * Test of getValue method, of class AbstractGraphNode.
     */
    @Test
    public void testGetValue() {
    }

    /**
     * Test of getKeys method, of class AbstractGraphNode.
     */
    @Test
    public void testGetKeys() {
    }
}