/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.graphnavigator;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Collection;
import java.util.Iterator;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.SwingWorker;
import javax.swing.Timer;
import org.gpdv.core.api.GraphView;
import org.netbeans.spi.navigator.NavigatorPanel;
import org.openide.nodes.Node;
import org.openide.util.Exceptions;
import org.openide.util.Lookup;
import org.openide.util.Lookup;
import org.openide.util.LookupEvent;
import org.openide.util.LookupListener;
import org.openide.util.NbBundle;
import org.openide.util.Utilities;

/**
 *
 * @author odi
 */
public class NavigatorPanelImpl implements NavigatorPanel, LookupListener {

    private GraphView graphView;
    private JComponent view;
    private Lookup lookup;
    Lookup.Result<GraphView> result;
    private JComponent panel;

    public String getDisplayName() {
        return NbBundle.getMessage(NavigatorPanelImpl.class, "displayname");
    }

    public String getDisplayHint() {
        return NbBundle.getMessage(NavigatorPanelImpl.class, "displayhint");
    }

    public JComponent getComponent() {
        return panel;
    }

    public void panelActivated(Lookup context) {
        this.panel = new JPanel();
        panel.setLayout(new BorderLayout());
        this.lookup = Utilities.actionsGlobalContext();
        result = lookup.lookupResult(GraphView.class);
        result.addLookupListener(this);
        result.allInstances();
        GraphView c = lookup.lookup(GraphView.class);
        if(c!=null){
            this.graphView = c;
            this.view = c.getSatelliteView();
            addView();
        }
    }

    public void panelDeactivated() {
        result.removeLookupListener(this);
    }

    public Lookup getLookup() {
        return null;
    }

    private void addView(){
        if(view!=null){
            panel.add(view, BorderLayout.CENTER);
            panel.revalidate();
            panel.repaint();
        }
    }

    public void resultChanged(LookupEvent ev) {
        GraphView c = lookup.lookup(GraphView.class);
        if(c!=null){
            panel.removeAll();
            this.graphView = c;
            this.view = graphView.getSatelliteView();
            addView();
        } else {
            panel.removeAll();
            this.view = graphView.getSatelliteView();
            addView();
        }
    }
}
