/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gpdv.graphviewtest;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Image;
import java.util.ArrayList;
import java.util.Collection;
import java.util.logging.Logger;
import javax.swing.JToolBar;
import org.gpdv.core.api.abstractgraph.AbstractGraph;
import org.gpdv.core.api.abstractgraph.AbstractGraphNode;
import org.gpdv.core.api.AbstractGraphFactory;
import org.gpdv.core.api.GraphView;
import org.gpdv.core.api.VisualizationRequest;
import org.gpdv.core.api.Visualizer;
import org.gpdv.services.GraphDesigner;
import org.openide.util.NbBundle;
import org.openide.windows.TopComponent;
import org.openide.windows.WindowManager;
//import org.openide.util.ImageUtilities;
import org.netbeans.api.settings.ConvertAsProperties;
import org.openide.util.ImageUtilities;
import org.openide.util.Lookup;
import org.openide.util.lookup.Lookups;

/**
 * Top component which displays something.
 */
@ConvertAsProperties(dtd = "-//org.gpdv.graphViewTest//GraphViewTest//EN",
autostore = false)
public final class GraphViewTestTopComponent extends TopComponent {

    private static GraphViewTestTopComponent instance;
    /** path to the icon used by the component and its open action */
//    static final String ICON_PATH = "SET/PATH/TO/ICON/HERE";
    private static final String PREFERRED_ID = "GraphViewTestTopComponent";

    private final int PH = 200;

    public GraphViewTestTopComponent() {
        initComponents();
        setName(NbBundle.getMessage(GraphViewTestTopComponent.class, "CTL_GraphViewTestTopComponent"));
        setToolTipText(NbBundle.getMessage(GraphViewTestTopComponent.class, "HINT_GraphViewTestTopComponent"));
//        setIcon(ImageUtilities.loadImage(ICON_PATH, true));
        AbstractGraphFactory factory = AbstractGraphFactory.getFactory();
        AbstractGraph g = factory.createAbstractGraph("Relationship graph", null);
        Image image = ImageUtilities.loadImage("org/gpdv/graphviewtest/bruce.jpg");
        image = image.getScaledInstance(-1, PH, Image.SCALE_FAST);
        AbstractGraphNode bruce = factory.createAbstractNode("Bruce", g, image);
        bruce.addProperty("Relationship status", "married");
        bruce.addProperty("Sex", "male");
        image = ImageUtilities.loadImage("org/gpdv/graphviewtest/john.jpg");
        image = image.getScaledInstance(-1, PH, Image.SCALE_FAST);
        AbstractGraphNode john = factory.createAbstractNode("John", g, image);
        john.addProperty("Relationship status", "divorced");
        john.addProperty("Sex", "male");
        image = ImageUtilities.loadImage("org/gpdv/graphviewtest/mike.jpg");
        image = image.getScaledInstance(-1, PH, Image.SCALE_FAST);
        AbstractGraphNode mike = factory.createAbstractNode("Mike", g, image);
        mike.addProperty("Relationship status", "in a relationship");
        mike.addProperty("Sex", "male");
        image = ImageUtilities.loadImage("org/gpdv/graphviewtest/emily.jpg");
        image = image.getScaledInstance(-1, PH, Image.SCALE_FAST);
        AbstractGraphNode emily = factory.createAbstractNode("Emily", g, image);
        emily.addProperty("Relationship status", "married");
        emily.addProperty("Sex", "female");
        image = ImageUtilities.loadImage("org/gpdv/graphviewtest/susan.jpg");
        image = image.getScaledInstance(-1, PH, Image.SCALE_FAST);
        AbstractGraphNode susan = factory.createAbstractNode("Susan", g, image);
        susan.addProperty("Relationship status", "widowed");
        susan.addProperty("Sex", "female");
        image = ImageUtilities.loadImage("org/gpdv/graphviewtest/sheila.jpg");
        image = image.getScaledInstance(-1, PH, Image.SCALE_FAST);
        AbstractGraphNode sheila = factory.createAbstractNode("Sheila", g, image);
        sheila.addProperty("Relationship status", "married");
        sheila.addProperty("Sex", "female");
        image = ImageUtilities.loadImage("org/gpdv/graphviewtest/stephanie.jpg");
        image = image.getScaledInstance(-1, PH, Image.SCALE_FAST);
        AbstractGraphNode stephanie = factory.createAbstractNode("Stephanie", g, image);
        stephanie.addProperty("Relationship status", "single");
        stephanie.addProperty("Sex", "female");
        AbstractGraphNode neil = factory.createAbstractNode("Neil", g, null);
        neil.addProperty("Relationship status", "single");
        neil.addProperty("Sex", "male");
        factory.createAbstractEdge(bruce.getName()+"->"+stephanie.getName(), g, bruce, stephanie, null);
        factory.createAbstractEdge(stephanie.getName()+"->"+john.getName(), g, stephanie, john, null);
        factory.createAbstractEdge(john.getName()+"->"+emily.getName(), g, john, emily, null);
        factory.createAbstractEdge(emily.getName()+"->"+bruce.getName(), g, emily, bruce, null);
        factory.createAbstractEdge(sheila.getName()+"->"+mike.getName(), g, sheila, mike, null);
        factory.createAbstractEdge(mike.getName()+"->"+susan.getName(), g, mike, susan, null);
        factory.createAbstractEdge(emily.getName()+"->"+sheila.getName(), g, emily, sheila, null);
        factory.createAbstractEdge(neil.getName(), g, neil, sheila, null);
        this.setLayout(new BorderLayout());
        Visualizer visualizer = Visualizer.getVisualizer();
        Collection<GraphDesigner> designers = Visualizer.Utils.getGraphDesignersForMimeType("image/png-gif-jpeg-bmp");
        GraphDesigner pref = null;
        for(GraphDesigner d : designers){
            if(d.getMimeTypes().contains("image/png-gif-jpeg-bmp")){
                pref = d;
                break;
            }
        }
        VisualizationRequest request = visualizer.getVisualizationRequest(g).setDesigners(new ArrayList<GraphDesigner>(designers)).setPreferredDesigner(pref);
        GraphView view = Visualizer.getVisualizer().getGraphView(request);
        this.add(view, BorderLayout.CENTER);
        JToolBar tb = view.getToolBar();
        if(tb!=null){
            this.add(tb, BorderLayout.NORTH);
        }
        this.associateLookup(view.getLookup());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    /**
     * Gets default instance. Do not use directly: reserved for *.settings files only,
     * i.e. deserialization routines; otherwise you could get a non-deserialized instance.
     * To obtain the singleton instance, use {@link #findInstance}.
     */
    public static synchronized GraphViewTestTopComponent getDefault() {
        if (instance == null) {
            instance = new GraphViewTestTopComponent();
        }
        return instance;
    }

    /**
     * Obtain the GraphViewTestTopComponent instance. Never call {@link #getDefault} directly!
     */
    public static synchronized GraphViewTestTopComponent findInstance() {
        TopComponent win = WindowManager.getDefault().findTopComponent(PREFERRED_ID);
        if (win == null) {
            Logger.getLogger(GraphViewTestTopComponent.class.getName()).warning(
                    "Cannot find " + PREFERRED_ID + " component. It will not be located properly in the window system.");
            return getDefault();
        }
        if (win instanceof GraphViewTestTopComponent) {
            return (GraphViewTestTopComponent) win;
        }
        Logger.getLogger(GraphViewTestTopComponent.class.getName()).warning(
                "There seem to be multiple components with the '" + PREFERRED_ID
                + "' ID. That is a potential source of errors and unexpected behavior.");
        return getDefault();
    }

    @Override
    public int getPersistenceType() {
        return TopComponent.PERSISTENCE_NEVER;
    }

    @Override
    public void componentOpened() {
        // TODO add custom code on component opening
    }

    @Override
    public void componentClosed() {
        // TODO add custom code on component closing
    }

    void writeProperties(java.util.Properties p) {
        // better to version settings since initial version as advocated at
        // http://wiki.apidesign.org/wiki/PropertyFiles
        p.setProperty("version", "1.0");
        // TODO store your settings
    }

    Object readProperties(java.util.Properties p) {
        if (instance == null) {
            instance = this;
        }
        instance.readPropertiesImpl(p);
        return instance;
    }

    private void readPropertiesImpl(java.util.Properties p) {
        String version = p.getProperty("version");
        // TODO read your settings according to their version
    }

    @Override
    protected String preferredID() {
        return PREFERRED_ID;
    }
}
