/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gpdv.graphviewtest;

import java.awt.BorderLayout;
import java.util.logging.Logger;
import org.gpdv.core.api.GraphView;
import org.gpdv.core.api.Visualizer;
import org.openide.util.NbBundle;
import org.openide.windows.TopComponent;
import org.openide.windows.WindowManager;
//import org.openide.util.ImageUtilities;
import org.netbeans.api.settings.ConvertAsProperties;
import org.openide.explorer.ExplorerManager;
import org.openide.explorer.ExplorerUtils;
import org.openide.explorer.view.BeanTreeView;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.Node;
import org.openide.util.Lookup;
import org.openide.util.lookup.ProxyLookup;

/**
 * Top component which displays something.
 */
@ConvertAsProperties(dtd = "-//org.gpdv.GraphViewTest//NodeVisualizer//EN",
autostore = false)
public final class NodeVisualizerTopComponent extends TopComponent implements ExplorerManager.Provider{

    private static NodeVisualizerTopComponent instance;
    /** path to the icon used by the component and its open action */
//    static final String ICON_PATH = "SET/PATH/TO/ICON/HERE";
    private static final String PREFERRED_ID = "NodeVisualizerTopComponent";
    private ExplorerManager manager;

    public NodeVisualizerTopComponent() {
        initComponents();
        setName(NbBundle.getMessage(NodeVisualizerTopComponent.class, "CTL_NodeVisualizerTopComponent"));
        setToolTipText(NbBundle.getMessage(NodeVisualizerTopComponent.class, "HINT_NodeVisualizerTopComponent"));
//        setIcon(ImageUtilities.loadImage(ICON_PATH, true));

        manager = new ExplorerManager();
        AbstractNode root = new AbstractNode(new MyChildren(10));
        manager.setRootContext(root);
        root.setName("Root");
        for(Node n : root.getChildren().getNodes()){
            System.out.print("");
        }
        System.out.println("");
        Visualizer v = Visualizer.getVisualizer();
        this.setLayout(new BorderLayout());
        GraphView view = v.getGraphView();
        this.add(new BeanTreeView(), BorderLayout.WEST);
        this.add(view, BorderLayout.CENTER);
        this.associateLookup(view.getLookup());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    /**
     * Gets default instance. Do not use directly: reserved for *.settings files only,
     * i.e. deserialization routines; otherwise you could get a non-deserialized instance.
     * To obtain the singleton instance, use {@link #findInstance}.
     */
    public static synchronized NodeVisualizerTopComponent getDefault() {
        if (instance == null) {
            instance = new NodeVisualizerTopComponent();
        }
        return instance;
    }

    /**
     * Obtain the NodeVisualizerTopComponent instance. Never call {@link #getDefault} directly!
     */
    public static synchronized NodeVisualizerTopComponent findInstance() {
        TopComponent win = WindowManager.getDefault().findTopComponent(PREFERRED_ID);
        if (win == null) {
            Logger.getLogger(NodeVisualizerTopComponent.class.getName()).warning(
                    "Cannot find " + PREFERRED_ID + " component. It will not be located properly in the window system.");
            return getDefault();
        }
        if (win instanceof NodeVisualizerTopComponent) {
            return (NodeVisualizerTopComponent) win;
        }
        Logger.getLogger(NodeVisualizerTopComponent.class.getName()).warning(
                "There seem to be multiple components with the '" + PREFERRED_ID
                + "' ID. That is a potential source of errors and unexpected behavior.");
        return getDefault();
    }

    @Override
    public int getPersistenceType() {
        return TopComponent.PERSISTENCE_NEVER;
    }

    @Override
    public void componentOpened() {
        // TODO add custom code on component opening
    }

    @Override
    public void componentClosed() {
        // TODO add custom code on component closing
    }

    void writeProperties(java.util.Properties p) {
        // better to version settings since initial version as advocated at
        // http://wiki.apidesign.org/wiki/PropertyFiles
        p.setProperty("version", "1.0");
        // TODO store your settings
    }

    Object readProperties(java.util.Properties p) {
        if (instance == null) {
            instance = this;
        }
        instance.readPropertiesImpl(p);
        return instance;
    }

    private void readPropertiesImpl(java.util.Properties p) {
        String version = p.getProperty("version");
        // TODO read your settings according to their version
    }

    @Override
    protected String preferredID() {
        return PREFERRED_ID;
    }

    public ExplorerManager getExplorerManager() {
        return manager;
    }
}
