/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gpdv.services.nodegraphbuilder;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Set;
import org.gpdv.services.GraphBuilder;
import org.gpdv.core.api.abstractgraph.AbstractGraphEdge;
import org.gpdv.core.api.abstractgraph.AbstractGraph;
import org.gpdv.core.api.abstractgraph.AbstractGraphNode;
import org.gpdv.core.api.AbstractGraphFactory;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.util.NbBundle;
import org.openide.util.lookup.ServiceProvider;

/**
 *
 * @author odi
 */
@ServiceProvider(service=GraphBuilder.class)

public class NodeGraphBuilderImpl implements GraphBuilder{

    private static ResourceBundle bundle = NbBundle.getBundle(NodeGraphBuilderImpl.class);

    private AbstractGraphFactory factory;
    private AbstractGraph graph;
    private Set<Class> acceptedClasses;
    private int c;

    public Node getRepresentation() {
        Node n = new org.openide.nodes.AbstractNode(Children.LEAF);
        n.setName(bundle.getString("NAME"));
        n.setDisplayName(bundle.getString("DISPLAYNAME"));
        n.setShortDescription(bundle.getString("DESCRIPTION"));
        return n;
    }

    public synchronized AbstractGraph buildGraph(Object object) {
        if(object==null){
            return null;
            //buildGraph();
        }
        if(!(object instanceof Node)){
            return null;
        }
        c = 0;
        Node root = (Node) object;
        if(factory==null) factory = AbstractGraphFactory.getFactory();
        AbstractGraph g = factory.createAbstractGraph(getGraphString(root.getDisplayName()), null);
        add(root, g);
        return g;
    }

    private AbstractGraphNode add(Node node, AbstractGraph g) {
        AbstractGraphNode n = factory.createAbstractNode(node.getDisplayName(), g, null);
        Node[] ch = node.getChildren().getNodes();
        for(Node no : ch){
            AbstractGraphNode s = add(no, g);
            AbstractGraphEdge e = factory.createAbstractEdge(bundle.getString("edge")+c, g, n, s, null);
            c++;
        }
        return n;
    }

    private String getGraphString(String s){
        StringBuilder b = new StringBuilder();
        b.append(bundle.getString("graph"));
        b.append(" ");
        b.append(s);
        return b.toString();
    }

    public boolean acceptsNull() {
        return false;
    }


//    private void buildGraph() {
//        throw new UnsupportedOperationException("Not yet implemented");
//        //TODO implement buildGraph() for NodeGraphBuilder
//    }

    public boolean accepts(Object object) {
        if(object==null) return acceptsNull();
        return(Node.class.isAssignableFrom(object.getClass()));
    }

    public Collection<String> getMimeTypes() {
        List<String> l = new ArrayList<String>();
        l.add(new String(bundle.getString("NODE")));
        return Collections.unmodifiableCollection(l);
    }

}
