/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gpdv.sourcebuildtestmodule;

import com.sun.source.tree.ClassTree;
import com.sun.source.util.TreePathScanner;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.IOException;
import java.util.Collection;
import java.util.List;
import javax.lang.model.element.Element;
import javax.lang.model.element.ElementKind;
import javax.lang.model.element.ExecutableElement;
import javax.lang.model.element.TypeElement;
import javax.lang.model.element.VariableElement;
import javax.lang.model.type.DeclaredType;
import javax.lang.model.type.TypeKind;
import javax.lang.model.type.TypeMirror;
import javax.swing.text.Document;
import org.gpdv.services.GraphBuilder;
import org.gpdv.services.GraphDesigner;
import org.gpdv.core.api.abstractgraph.AbstractGraph;
import org.gpdv.core.api.Visualizer;
import org.netbeans.api.actions.Openable;
import org.netbeans.api.java.source.CompilationController;
import org.netbeans.api.java.source.CompilationInfo;
import org.netbeans.api.java.source.JavaSource;
import org.netbeans.api.java.source.JavaSource.Phase;
import org.netbeans.api.java.source.Task;
import org.openide.awt.StatusDisplayer;
import org.openide.filesystems.FileObject;
import org.openide.loaders.DataObject;
import org.openide.util.Exceptions;
import org.openide.windows.IOProvider;
import org.openide.windows.InputOutput;

public final class DoAction implements ActionListener {

    private final DataObject context;

    public DoAction(DataObject context) {
        this.context = context;
    }

    public void actionPerformed(ActionEvent ev){
        FileObject fo = context.getPrimaryFile();
        Collection<? extends GraphBuilder> builders = Visualizer.Utils.getGraphBuildersForMimeType(fo.getMIMEType());
        GraphBuilder builder = null;
        for(GraphBuilder b : builders){
            if(b.accepts(fo)){
                builder = b;
                break;
            }
        }
        GraphDesigner d = null;
        for(GraphDesigner de : Visualizer.Utils.getGraphDesignersForMimeType("java/class")){
            if(de.getRepresentation().getName().startsWith("CLASS")){
                d = de;
//                System.out.println(de);
                break;
            }
        }
        if(builder!=null){
            AbstractGraph g = builder.buildGraph(fo);
            if(g!=null){
                Visualizer.getVisualizer().visualize(Visualizer.getVisualizer().getVisualizationRequest(g).setPreferredDesigner(d));
            }
        }
    }
}
